package Libs::ADI;

#####################################

=head1 COPYRIGHT

  Copyright Notice
  ================

  Copyright 2004 Neuronix

  Copying Permission
  ------------------

  This script is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

  ********************************************************************

=head1 INFO

  Script Info
  ===========

  Author        : Neuronix
                     aka Nikolay Viguro

  Project       : nX - Engine (Codename: XEN)
                    This is CMS engine, writted on Perl language.

  Script        : ADI.pm
                    This is system package.
                    Provide Administarative Interface functions.

  Started      : 15/02/2004

=cut

#########################################

require 5.004;        # Need perl dist >= 5.004

use strict;
use locale;
use Libs::API;

our $VERSION = "0.4.3-test"; # Version of ADI
our $API = new Libs::API(); # Initalize API constructor

our %config = $API->readConfig("Config");
our %info = $API->getForms();
our %cook = $API->getCookies();

############## End Init ###################
########################################

sub new  # The ADI constructor
{
    my($class, %conf) = @_;
    my $self = bless {
              initMods => 0,
              readConf => 1,
                               }, $class;

    $API->initAllModules("Modules") if $conf{'initMods'};
    $API->initAllModules("Skins") if $conf{'initMods'};
    our %config = $API->readConfig("Config") if $conf{'readConf'};

    return $self;
}

########### End Constructor ###############
########################################

sub DESTROY { }

#########################################
############ ADI Functions ################
#########################################

sub printPage
{
   my ($self, $center, $mode) = @_;

   print $API->printHeader("Administration") if !$mode;   # Printering headers.

   my $leftSide = $API->printSideBlock("Left", 0, "Login");
         $leftSide .= $API->printBlock("Admin Panel", admBlock()) if $cook{'login'} ne "" && $cook{'passwd'} ne ""
                                                     && $API->isUserValid() && $API->isUserAdmin($cook{'login'});

   ### Linking ###
   #############

   print $API->printBody($leftSide, "", $center);
   print $API->printFooter();

   exit(0);
}

#########################################

sub admBlock
{
   my $globPrint;
   my $newTotal = 0;
   my $total = 0;

            my $sth = $Libs::API::dbh->prepare("SELECT * FROM ${Libs::API::dbPrefix}_Module_Contact");
           $sth->execute();

               while (my $ref = $sth->fetchrow_hashref())
                  {
                   $newTotal++ if $ref->{'IsNew'} == "1";
                   $total++;
                  }

           $sth->finish();

   $globPrint = "&nbsp;<strong><big>&middot;</big></strong>&nbsp;<a href=\"admin.cgi?action=main\"> </a><br>\n";
   $globPrint .= "&nbsp;<strong><big>&middot;</big></strong>&nbsp;<a href=\"admin.cgi?do=News&param=add\"> </a><br>\n";
   $globPrint .= "&nbsp;<strong><big>&middot;</big></strong>&nbsp;<a href=\"admin.cgi?action=logout\"></a><br>\n";
   $globPrint .= "<br>&nbsp;<strong><big>&middot;</big></strong>&nbsp;<b><a href=\"admin.cgi?do=Contact\"></a></b>: "
                          if $Libs::API::modList{"Contact"} != 0;
   $globPrint .= "(<blink><a href=\"admin.cgi?do=Contact\">$newTotal</a></blink>|<a href=\"admin.cgi?do=Contact&type=answered\">$total</a>)<br>\n"
                          if $newTotal != 0 && $Libs::API::modList{"Contact"} != 0;
   $globPrint .= "(0|$total)<br>\n" if $newTotal == 0  && $Libs::API::modList{"Contact"} != 0;

   return $globPrint;
}

#=============================================================

sub viewDirContentAdmin
{
    my ($self, $dir, $disk) = @_;
    my $mod;
    my $content;

    my %d;

    my $lnt = length($dir);
    my $upper = substr $dir, 0, $lnt-2;

    if(length($upper) <= 2) { $upper = "${disk}0"; }

    ##################

   $mod = "Docs" if $disk eq "S";               #    
   $mod = "Downloads" if $disk eq "D";       #      . !

   ###################

    my @html = $API->readFile("Skins/$Libs::API::skin/fs/Explore.html");

    if ($dir ne "${disk}0") { $content = "<td width=33% class=textbg align=center><a href=\"admin.cgi?do=$mod\&dir=$upper\">
                            <img border=0 src=\"\/Skins\/$Libs::API::skin\/images\/dir_small.png\">
                            <b>..</b></a></td>"; }

        %d = $API->db_get_hash_query("SELECT Name FROM ${Libs::API::dbPrefix}_FS WHERE CTID=\"$dir\"", "Name");

        if($d{'Name'} eq "") { $d{'Name'} = "Root"; }

         my $sth = $Libs::API::dbh->prepare("SELECT CTID, Name, IsGuestVisible FROM ${Libs::API::dbPrefix}_FS WHERE CTID LIKE \"\%$dir\%\"");
               $sth->execute();

               my $C;
               my $totalCnt;

       if($dir ne "${disk}0") { $C = 1; } else { $C = 0; }
       if($dir ne "${disk}0") { $totalCnt = 1; } else { $totalCnt = 0; }

               my $globalPrint;

               while (my $ref = $sth->fetchrow_hashref())
                 {

                 if(length($ref->{"CTID"}) == $lnt+2)
                   {
                       $content .=
                    "<td width=33% class=textbg  align=center><a href=\"admin.cgi?do=$mod\&dir=$ref->{'CTID'}\">
                     <b>$ref->{\"Name\"}</b></a><br>
                     (<a href=\"admin.cgi?do=$mod\&dir=$dir\&tdir=$ref->{'CTID'}\&act=dirdel\"><font color=darkred></font></a>";

                     if(!$ref->{'IsGuestVisible'})
                     {
                      $content .= "|<a href=\"admin.cgi?do=$mod\&dir=$dir\&tdir=$ref->{'CTID'}\&act=guest\"><font color=darkred>
                                          </font></font></a>";
                     }
                      else
                    {
                      $content .= "|<a href=\"admin.cgi?do=$mod\&dir=$dir\&tdir=$ref->{'CTID'}\&act=noguest\"><font color=darkgreen>
                                          </font></font></a>";
                    }

                      $content .= "|<br><a href=\"admin.cgi?do=$mod\&dir=$dir\&tdir=$ref->{'CTID'}\&act=dirrename\"><font color=darkred>
                                         </font></font></a>";

                    $content .= ")</td>\n";

                     $C++;
                     ++$totalCnt;
                   }

                    if($C == 3) { if($dir ne "${disk}0") { $content .= "\n</tr><tr>\n"; $C = 1; } else { $content .= "\n</tr><tr>\n"; $C = 0; } }

                 }

                 $content .= "<td class=textbg align=center><div><b>  !</b></div</td>" if $totalCnt == 0;

                 $mod .= "\/$d{'Name'}";

                foreach my $line (@html)
                   {
                       $line =~ s/__FILES__/$content/eg;
                     $line =~ s/__MODULE__/$mod/eg;
                     $line =~ s/__TOTALDIRS__/$totalCnt/eg;

                     $globalPrint .= $line;
                   }

    return $globalPrint;
}

#=============================================================

sub fsViewRenameForm
{
        my ($self, $dir, $tdir, $mod) = @_;
        my $globalPrint;

        $API->db_get_hash_query("SELECT Name FROM ${Libs::API::dbPrefix}_FS WHERE CTID=\"$tdir\"", "Name");

        my @html = $API->readFile("Skins/$Libs::API::skin/fs/Rename.html");

                foreach my $line (@html)
                   {
                     $line =~ s/__CURRENTNAME__/$_{'Name'}/eg;
                     $line =~ s/__MODULE__/$mod/eg;
                     $line =~ s/__DIR__/$dir/eg;
                     $line =~ s/__TDIR__/$tdir/eg;

                     $globalPrint .= $line;
                   }

        return $globalPrint;
}

sub fsDirCreate
{
    my ($self, $currDir, $dirName) = @_;
    my $last = 0;
    my $curr;
    my $new;

    my $lnt = length($currDir);

    ##################

            my $sth = $Libs::API::dbh->prepare("SELECT CTID FROM ${Libs::API::dbPrefix}_FS WHERE CTID LIKE \"\%$currDir\%\"");
               $sth->execute();

               while (my $ref = $sth->fetchrow_hashref())
                 {


                 if(length($ref->{'CTID'}) == $lnt+2)
                   {
                        $curr = substr $ref->{'CTID'}, $lnt+1;

                         if ($curr > $last)
                          {
                            $new = $curr;
                          }

                          $last = $curr;
                   }
                 }

        $new++;

        $currDir = "$currDir\-$new";

            $API->db_do_query("INSERT INTO ${Libs::API::dbPrefix}_FS VALUES (\"$currDir\", \"$dirName\", 1)");

    return 0;
}

#=============================================================

sub fsDirDelete
{
    my ($self, $dirCTID, $table) = @_;

    ##################

            $API->db_do_query("DELETE FROM ${Libs::API::dbPrefix}_FS WHERE CTID=\"$dirCTID\"");
            $API->db_do_query("DELETE FROM ${Libs::API::dbPrefix}_Module_${table} WHERE FS=\"$dirCTID\"");

    return 0;
}

sub fsDirRename
{
    my ($self, $dirCTID, $newName) = @_;

    ##################

            $API->db_do_query("UPDATE ${Libs::API::dbPrefix}_FS SET Name=\"$newName\" WHERE CTID=\"$dirCTID\"");

    return 0;
}

sub fsDirSetGuestVisible
{
    my ($self, $dirCTID, $action) = @_;

    ##################

            $API->db_do_query("UPDATE ${Libs::API::dbPrefix}_FS SET IsGuestVisible=$action WHERE CTID=\"$dirCTID\"");

    return 0;
}

#########################################

sub uploadFormView
{
        my ($self, $mod, $dir) = @_;
        my %cfg = $API->readConfig("Config");
        my $globalPrint;
        my $name;
        my @html;

        if($cfg{'uploadDocsDisabled'} == 1 && $mod eq "Docs" || $cfg{'uploadDownloadsDisabled'} == 1 && $mod eq "Downloads")
        {
                return "<br>".$API->printBlock("", "<br><center><b></b><br>     !<br>");
        }

        if(!$API->isUserValid())
        {
                return "<br>".$API->printBlock("", "<br><center> <i></i>     !<br><br>
                <a href=\"http://www.neuro.net/pages.cgi?name=Login&do=reg\"></a><br></center>");
        }

        $API->db_get_hash_query("SELECT Name FROM ${Libs::API::dbPrefix}_FS WHERE CTID=\"$dir\"", "Name");

         if($_{'Name'} eq "") { $name = "Root"; } else { $name = $_{'Name'}; }

        if($mod eq "Downloads")
                 { @html = $API->readFile("Skins/$Libs::API::skin/fs/DownloadsUpload.html"); } else
                 { @html = $API->readFile("Skins/$Libs::API::skin/fs/DocsUpload.html"); }

                foreach my $line (@html)
                   {
                     $line =~ s/__CURRENTNAME__/$name/eg;
                     $line =~ s/__MODULE__/$mod/eg;
                     $line =~ s/__DIR__/$dir/eg;

                     $globalPrint .= $line;
                   }

        return $globalPrint;
}

#########################################

sub Upload
{
        my ($self, $mod, $dir, %info) = @_;
        my $new;
        my $last;

        return if !$API->isUserValid();

        my $date = $Libs::API::localtime;

                    $info{'filedesc'} =~ s/&lt;/\</g;
                    $info{'filedesc'} =~ s/&gt;/\>/g;
                    $info{'filedesc'} =~ s/&quot;/\"/g;
                    $info{'filedesc'} =~ s/\&\#58;/:/g;
                    $info{'filedesc'} =~ s/\n/<br>/g;

            $info{'filedesc'} = " " if $info{'filedesc'} eq "";

if($mod eq "Docs")
{
        $info{'filecontent'} =~ s/&lt;/\</g;
        $info{'filecontent'} =~ s/&gt;/\>/g;
        $info{'filecontent'} =~ s/&quot;/\"/g;
        $info{'filecontent'} =~ s/\&\#58;/:/g;
        $info{'filecontent'} =~ s/\n/<br>/g;

        my $sth = $Libs::API::dbh->prepare("SELECT * FROM ${Libs::API::dbPrefix}_Module_Docs");
           $sth->execute();

               while (my $ref = $sth->fetchrow_hashref())
                 {
                         if ($ref->{'SID'} > $last)
                          {
                            $new = $ref->{'SID'};
                          }

                          $last = $ref->{'SID'};
                 }

           $sth->finish();

                 $new++;

    $API->db_do_query("INSERT INTO ${Libs::API::dbPrefix}_Module_Docs
                                   VALUES (\"$new\",
                                           \"$date\",
                                           \"$cook{'login'}\",
                                           \"$info{'filename'}\",
                                           \"$info{'filedesc'}\",
                                           \"$info{'filecontent'}\",
                                           \"0\",
                                           \"0\",
                                           \"1\",
                                           \"$dir\")");

    $API->db_get_hash_query("SELECT StoryAdded FROM ${Libs::API::dbPrefix}_Module_Users
                                            WHERE UserName=\"$cook{'login'}\"","StoryAdded");

      my $t = $_{'StoryAdded'}+1;
      $API->db_do_query("UPDATE ${Libs::API::dbPrefix}_Module_Users
                                     SET StoryAdded=$t WHERE UserName=\"$cook{'login'}\"");
}
else
{
            $info{'filesize'} = " " if $info{'size'} !~ /\d+.*/;

                    $info{'fileurl'} =~ s/&quot;/\"/g;
                    $info{'fileurl'} =~ s/\&\#58;/:/g;

        my $sth = $Libs::API::dbh->prepare("SELECT * FROM ${Libs::API::dbPrefix}_Module_Downloads");
           $sth->execute();

               while (my $ref = $sth->fetchrow_hashref())
                 {
                         if ($ref->{'DID'} > $last)
                          {
                            $new = $ref->{'DID'};
                          }

                          $last = $ref->{'DID'};
                 }

           $sth->finish();

                 $new++;

    $API->db_do_query("INSERT INTO ${Libs::API::dbPrefix}_Module_Downloads
                                   VALUES (\"$new\",
                                           \"$date\",
                                           \"$cook{'login'}\",
                                           \"$info{'filename'}\",
                                           \"$info{'filedesc'}\",
                                           \"$info{'fileurl'}\",
                                           \"$info{'filesize'}\",
                                           \"0\",
                                           \"0\",
                                           \"1\",
                                           \"$info{'dir'}\")");

    $API->db_get_hash_query("SELECT FilesAdded FROM ${Libs::API::dbPrefix}_Module_Users
                                            WHERE UserName=\"$cook{'login'}\"","FilesAdded");

      my $t = $_{'FilesAdded'}+1;
      $API->db_do_query("UPDATE ${Libs::API::dbPrefix}_Module_Users
                                     SET FilesAdded=$t WHERE UserName=\"$cook{'login'}\"");
}

           my $total = $API->db_rows_count("SELECT ID FROM ${Libs::API::dbPrefix}_Module_Contact");
           $total++;

           my%d = $API->db_get_hash_query("SELECT Name FROM ${Libs::API::dbPrefix}_FS WHERE CTID=\"$info{'dir'}\"", "Name");

                if($d{'Name'} eq "") { $d{'Name'} = "Root"; }

        $API->db_do_query("INSERT INTO ${Libs::API::dbPrefix}_Module_Contact VALUES (\"$total\", \"$date\", \"\",
                         \"\", \"  <b><i>$mod</i></b>
         ( <b><a href=admin.cgi?do=$mod&dir=$info{'dir'}>$d{'Name'}</a></b>)   /  <b>$cook{'login'}</b>.\",
                                         1, 0, \"\")"); #  .

        return "<br>".$API->printBlock("", "<br><center><b></b><br>       !<br>");
}

#########################################

sub setCookies
{
        my ($self, $time) = @_;
        my $pass = $API->genMD5($info{'passwd'});
        print "Set-Cookie: login=".$API->escape($info{'login'})."; expires=".$API->expires($time)."\n";
        print "Set-Cookie: passwd=".$API->escape($pass)."; expires=".$API->expires($time)."\n";
        return $self;
}

#########################################

sub Login
{
 my $self = shift;
 my $content;

     my @content = $API->readFile("Skins/$Libs::API::skin/admenter.html");
     foreach my $line (@content)
     {  $content .= $line;  }

  $self->printPage($content);
}

#########################################

sub Jump
{
   my ($self, $place, $time, $alt) = @_;

   $self->setCookies($time) if $time ne "";

   print "Location: admin.cgi?$place\n" if !$alt;
   print "Location: $place\n" if $alt;
   print "Status: 302 Temporary moved\n\n";

   exit(0);
}

#########################################

        sub ModOnOff($$$)
        {
            my ($self, $table, $action) = @_;

                  $API->db_do_query("UPDATE ${Libs::API::dbPrefix}_$table SET Active=\"$action\"  WHERE BlockName=\"$info{'name'}\"");

            return 1;
        }

#########################################

        sub ModIndex($$$)
        {
            my ($self, $action, $isBlock) = @_;
            my $side = $info{'side'};

                  $API->db_do_query("UPDATE ${Libs::API::dbPrefix}_${side}Block SET OnIndex=\"$action\"  WHERE BlockName=\"$info{'name'}\"");
                  $API->db_do_query("UPDATE ${Libs::API::dbPrefix}_Blocks SET OnIndex=\"$action\"  WHERE BlockName=\"$info{'name'}\"") if $isBlock;

            return 1;
        }

#########################################

        sub ModAlwLoad($$)
        {
            my ($self, $action) = @_;

                  $API->db_do_query("UPDATE ${Libs::API::dbPrefix}_Modules SET IsAlwLoad=\"$action\"  WHERE BlockName=\"$info{'name'}\"");

            return 1;
        }

#########################################

        sub chgPos
        {
            my ($self, $from, $to, $table) = @_;

                  $API->db_do_query("UPDATE ${Libs::API::dbPrefix}_$table SET Position=\"0999\" WHERE Position=\"$to\"");
                  $API->db_do_query("UPDATE ${Libs::API::dbPrefix}_$table SET Position=\"$to\" WHERE Position=\"$from\"");
                  $API->db_do_query("UPDATE ${Libs::API::dbPrefix}_$table SET Position=\"$from\" WHERE Position=\"0999\"");

            return 0;
        }

#########################################

        sub chgSide
        {
            my ($self, $from, $to, $name, $isBlock) = @_;
            my %from;

            my $toRows = $API->db_rows_count("SELECT * FROM ${Libs::API::dbPrefix}_${to}Block");
                  $toRows++;

            if($from ne "none")
            {
                %from = $API->db_get_hash_query("SELECT Position, OnIndex, Type FROM ${Libs::API::dbPrefix}_${from}Block WHERE BlockName=\"$name\"",
                                                                                 "Position, OnIndex, Type");

                $API->db_do_query("DELETE FROM ${Libs::API::dbPrefix}_${from}Block WHERE BlockName=\"$name\"");

                  $API->db_do_query("INSERT INTO ${Libs::API::dbPrefix}_${to}Block VALUES
                                                 (\"$toRows\", \"$from{'OnIndex'}\", \"$name\", \"$from{'Type'}\")");
            }
            else
            {

                 %from = $API->db_get_hash_query("SELECT Date, Type FROM ${Libs::API::dbPrefix}_Modules WHERE BlockName=\"$name\"",
                                                                                 "Date, Type") if !$isBlock;

                 %from = $API->db_get_hash_query("SELECT Date, Type FROM ${Libs::API::dbPrefix}_Blocks WHERE BlockName=\"$name\"",
                                                                                 "Date, Type") if $isBlock;

                  my %u = $API->db_get_hash_query("SELECT BlockName FROM ${Libs::API::dbPrefix}_${to}Block WHERE BlockName=\"$name\"",
                                                                                "BlockName");

                  $self->printPage("<br><center><b>      !</b></center>") if $u{'BlockName'} ne "";

                  $API->db_do_query("INSERT INTO ${Libs::API::dbPrefix}_${to}Block VALUES
                                                 (\"$toRows\", \"1\", \"$name\", \"$from{'Type'}\")") if !$isBlock;

                  $API->db_do_query("INSERT INTO ${Libs::API::dbPrefix}_${to}Block VALUES
                                                 (\"$toRows\", \"1\", \"$name\", \"Block\")") if $isBlock;
            }

            return 0;
        }

#########################################

        sub delMod
        {
            my ($self, $from, $name) = @_;

                        $API->db_do_query("DELETE FROM ${Libs::API::dbPrefix}_${from}Block WHERE BlockName=\"$name\"");

            return 0;
        }

######################################### Group permissions (29.11.04 Nix)

        sub isUserAccess
        {
            my ($self, $page, $user) = @_;

              $API->db_get_hash_query("SELECT * FROM ${Libs::API::dbPrefix}_Permissions WHERE GroupUsers LIKE \"\%$user\%\"", "PageAccess");

              if($_{'PageAccess'} =~ $page || $_{'PageAccess'} eq "All") { return 1; }

            return 0;
        }

#########################################

        sub sysInfo
        {
            my %sys;

            $sys{'OS'} = $^O;

            $sys{'Software'} = $ENV{'SERVER_SOFTWARE'};
            $sys{'ServerAdmin'} = $ENV{'SERVER_ADMIN'};
            $sys{'ServerAddress'} = $ENV{'SERVER_ADDR'};
            $sys{'Perl'} = $];
            $sys{'Host'} = $ENV{'HTTP_HOST'};

            if($sys{'OS'} =~ /linux/ || $sys{'OS'} =~ /bsd/ || $sys{'OS'} =~ /macos/)
            {
              my $uname = `uname -a`;
                    $uname =~ /^.*?\s(.*?)\s(.*?)\s.*/;

                    $sys{'Host'} = $1;
                    $sys{'Kernel'} = $2;

              my $uptime = `uptime`;
                    $uptime =~ /(.*)/;

                    $sys{'Uptime'} = $1;

              my $mysql = `mysql -V`;
                    $mysql =~ /^.*?\s.Ver\s.*?Distrib\s(.*?),.*/;

                    $sys{'MySQL'} = $1;
            }

            return %sys;
        }

#########################################

1;
