##############################
#
#       nX - Guestbook
#         (Codename: XEN-Guest)
#            Admin Interface.
#
#     This script is a part of
#           XEN CMS
#
#     Writted by NeuroniX
#       aka Viguro Nikolay
#        neuronix666@yandex.ru
#
#         Started at 22/05/04
#
##############################

#--------------- Initialize ----------------#

use Libs::ADI;

sub GuestAdmin
{
   our ($self, %info) = @_;
   my $idTotal;

   our $ADI = new Libs::ADI ( initMods => 1,
                                            readConf => 1 ); # Initalize ADI constructor

   our %config = $self->readConfig("Config");
   our %lang = $self->readConfig("Language");
   our %cook = $self->getCookies();

   if($info{'param'} eq 'edit') { $ADI->printPage($self->saveEdit()); }
   if($info{'param'} eq 'del') { $ADI->printPage($self->delEdit()); }

   $ADI->printPage($self->editGuest($info{'id'}));

   ######################
   ######################

sub editGuest
{
  my ($self, $id) = @_;
  my $page = $info{'page'};
  my $msgtmp;

  $id = 0 if $id !~ /\d+/;

  if($page =~ /(\d+)/) { if($page =~ /\-/) { $page = 1; } else {$page = $1; }} else { $page = 1; }

    $total = $self->db_rows_count("SELECT * FROM ${Libs::API::dbPrefix}_Module_Guest_Data WHERE ID=$id");

##############################################

      my $pgLeft = $page-1;
      my $pgRight = $page+1;

    if($page*$config{'guestMaxMsgOnPage'} > $total && $total > $config{'guestMaxMsgOnPage'} )
     { $nPage = "<a href=\"admin.cgi?do=Guest&page=$pgLeft\">&lt;&lt;</a> $page"; }
    else
     {
      if($page-1 == 0) { $nPage = "$page <a href=\"admin.cgi?do=Guest&page=$pgRight\">&gt;&gt;</a>"; }
      else
      {
      $nPage = "<a href=\"admin.cgi?do=Guest&page=$pgLeft\">&lt;&lt; </a>$page<a href=\"admin.cgi?do=Guest&page=$pgRight\"> &gt;&gt;</a>"; }
     }

         if($total <= $config{'guestMaxMsgOnPage'}) { $nPage = "| 1 |"; }

  #---------------------------------------------------#

##############################################
##############################################

    return viewEmpty() if $total == 0 || $total eq '';

     my $from = $total-($page*$config{'guestMaxMsgOnPage'}-$config{'guestMaxMsgOnPage'})+1;
     my $to = $from-$config{'guestMaxMsgOnPage'};

     $to = 1 if $to <= 1;
     $from = 0 if $from <= 1;
     $from -= 1 if $page != 1;

          if($to > $config{'guestMaxMsgOnPage'}) { $to = $config{'guestMaxMsgOnPage'}; }

    for (my $i=$from;$i>=$to;$i--)
     {
       $self->db_get_hash_query("SELECT * FROM ${Libs::API::dbPrefix}_Module_Guest_Data WHERE ID=\"$id\" AND Cnt=\"$i\";",
                                              "Date, Time, Name, EMail, Home, Message, AdmAnswer, IP");

         my  %t = %_;
         my  $totalMSG = 0;

         next if $t{'Date'} eq "";

        $totalMSG = $self->db_rows_count("SELECT ID FROM ${Libs::API::dbPrefix}_Module_Guest_Data WHERE ID=\"$id\" AND Cnt=\"$i\"");

           $t{'Message'} =~ s/<br>/\n/g;
           $t{'AdmAnswer'} =~ s/<br>/\n/g;

                 my @html = $self->readFile("Skins/$Libs::API::skin/guest/AdmGuestBlock.html");

                 foreach my $line (@html)
                   {
                             $line =~ s/__DATE__/$t{'Date'}/eg;
                             $line =~ s/__TIME__/$t{'Time'}/eg;
                             $line =~ s/__IP__/$t{'IP'}/eg;
                             $line =~ s/__CONTENT__/$t{'Message'}/eg;
                             $line =~ s/__USER__/$t{'Name'}/eg;
                             $line =~ s/__EMAIL__/$t{'EMail'}/eg;
                             $line =~ s/__HOME__/$t{'Home'}/eg;
                             $line =~ s/__ADMANSWER__/$t{'AdmAnswer'}/eg;
                             $line =~ s/__ID__/$id/eg;
                             $line =~ s/__CNT__/$i/eg;
                             $line =~ s/<!-- _1_ -->/$lang{'date'}/eg;
                             $line =~ s/<!-- _2_ --> /$lang{'nick'}/eg;

                                $msgtmp .= $line;
                   }
                                        %_ = ();
     }

##############################################

     $msgtmp .= "<br><center>$nPage</center>";

##############################################

sub viewEmpty
{
     my @html = $self->readFile("Skins/$Libs::API::$skin/guest/empty.html");

     foreach my $line (@html)
      {
        $msgtmp .= $line;
      }

   return $msgtmp;
}

##############################################

return $msgtmp;
}

##############################################

sub saveEdit
{
  my $self = shift;
  my $id = $info{'idnum'};

    $info{'message'} =~ s/&gt;/>/g;
    $info{'message'} =~ s/&lt;/</g;
    $info{'admanswer'} =~ s/&gt;/>/g;
    $info{'admanswer'} =~ s/&lt;/</g;
    $info{'time'} =~ s/\&#58;/:/g;

      $self->db_do_query("UPDATE ${Libs::API::dbPrefix}_Module_Guest_Data
                                     SET ID=$info{'id'}, Cnt=\"$info{'cnt'}\", Date=\"$info{'date'}\", Time=\"$info{'time'}\", Name=\"$info{'name'}\", EMail=\"$info{'email'}\",
                                     Home=\"$info{'home'}\", Message=\"$info{'message'}\", AdmAnswer=\"$info{'admanswer'}\"
                                     WHERE ID=$id AND Cnt=$info{'cntnum'}");

  return "<center><br><b> ...</b></center>";
}

##############################################

##############################################

sub delEdit
{
  my $self = shift;
  my $id = $info{'idnum'};
  my $cnt = $info{'cnt'};

      $self->db_do_query("DELETE FROM ${Libs::API::dbPrefix}_Module_Guest_Data WHERE ID=$id AND Cnt=$cnt");

  return "<center><br><b> ...</b></center>";
}

##############################################

   return undef;
}

1;
