##############################
#
#       nX - News
#         (Codename: XEN-News)
#            Admin Interface.
#
#     This script is a part of
#           XEN CMS
#
#     Writted by NeuroniX
#       aka Viguro Nikolay
#        neuronix666@yandex.ru
#
#         Started at 14/02/04
#
##############################

#--------------- Initialize ----------------#

use Libs::ADI;

sub NewsAdmin
{
   our ($self, %info) = @_;
   our $idTotal;

   our $ADI = new Libs::ADI ( initMods => 1,
                                         readConf => 1 ); # Initalize ADI constructor

   our %conf = $self->readConfig("Config");
   our %lang = $self->readConfig("Language");
   our %cook = $self->getCookies();

	$idTotal = $self->db_rows_count("SELECT ID FROM ${Libs::API::dbPrefix}_Module_News_Data");

   if($info{'param'} eq 'add' && $info{'Name'} ne '' && $info{'Title'} ne '' && $info{'Message'} ne '') { addNews(); }
   if($info{'param'} eq 'add') { viewForm(); }
   if($info{'param'} eq 'edit') { $ADI->printPage($self->saveEdit()); }
   if($info{'param'} eq 'del') { $ADI->printPage($self->delEdit()); }

   $ADI->printPage($self->editNews());

   ######################
   ######################

   sub addNews
   {
     my $localtime= $Libs::API::localtime;
     $idTotal++;

     %info = $self->retchr(%info);

     $info{'Message'} =~ s/:/&#58;/ig;
     $info{'Message'} =~ s/\"/'/ig;
     $info{'Title'} =~ s/:/&#58;/ig;

    $self->db_do_query("INSERT INTO ${Libs::API::dbPrefix}_Module_News_Data
    				 (ID, Date, Name, Title, Message) VALUES (\"$idTotal\", \"$localtime\", \"$info{'Name'}\", \"$info{'Title'}\", \"$info{'Message'}\")");


    ########################
    ########################

    $self->db_get_hash_query("SELECT UserName, NewsAdded FROM ${Libs::API::dbPrefix}_Module_Users
    					    WHERE UserName=\"$info{'Name'}\"","UserName, NewsAdded");

      my $c = $_{'NewsAdded'}+1;
      $self->db_do_query("UPDATE ${Libs::API::dbPrefix}_Module_Users SET NewsAdded=$c WHERE UserName=\"$info{'Name'}\"");

    ########################
    ########################

    $ADI->printPage("<br><center><b>   ...</b></center>\n");
  }

   ######################

   sub viewForm
   {
     my $center;
     my @data= $self->readFile("Skins/$Libs::API::skin/news/AdmAdd.html");

	  foreach my $line (@data)
	     {
	       $line =~ s/__USER__/$cook{'login'}/eg;
               $center .= $line;
             }

      $ADI->printPage($center);
    }

   #####################
   #####################


sub editNews
{
  my $self = shift;
  my $page = $info{'page'};
  my $msgtmp = "<center><br><< <a href=admin.cgi?do=News&param=add> </a> >><br><br></center>";

  if($page eq '' || $page ==0 || $page =~ /-/) { $page = 1; }

  $total = $self->db_rows_count("SELECT * FROM ${Libs::API::dbPrefix}_Module_News_Data");

  #---------------------------------------------------#

      my $pgLeft = $page-1;
      my $pgRight = $page+1;

    if($page*$conf{'newsMaxMsgOnPage'} > $total && $total > $conf{'newsMaxMsgOnPage'} )
     { $nPage = "<a href=\"admin.cgi?do=News&page=$pgLeft\">&lt;&lt;</a> $page"; }
    else
     {
      if($page-1 == 0) { $nPage = "$page <a href=\"admin.cgi?do=News&page=$pgRight\">&gt;&gt;</a>"; }
      else
      {
      $nPage = "<a href=\"admin.cgi?do=News&page=$pgLeft\">&lt;&lt; </a>$page<a href=\"admin.cgi?do=News&page=$pgRight\"> &gt;&gt;</a>"; }
     }

         if($total <= $conf{'newsMaxMsgOnPage'}) { $nPage = "| 1 |"; }

  #---------------------------------------------------#

############################
############################

    return viewEmpty() if $total == 0 || $total eq '';

     my $from = $total-($page*$conf{'newsMaxMsgOnPage'}-$conf{'newsMaxMsgOnPage'})+1;
     my $to = $from-$conf{'newsMaxMsgOnPage'};

     $to = 1 if $to <= 1;
     $from = 0 if $from <= 1;
     $from -= 1 if $page != 1;

#   if($to > $conf{'newsMaxMsgOnPage'}) { $to = $conf{'newsMaxMsgOnPage'}; }

    for (my $i=$from;$i>=$to;$i--)
     {
       $self->db_get_hash_query("SELECT * FROM ${Libs::API::dbPrefix}_Module_News_Data WHERE ID=\"$i\";","Date, Name, Title, Message");

         my  %t = %_;
	 my  $totalMSG = 0;

	next if $t{'Date'} eq '';

	$totalMSG = $self->db_rows_count("SELECT ID FROM ${Libs::API::dbPrefix}_Module_Guest_Data WHERE ID=\"$i\"");

	   $t{'Message'} =~ s/<br>/\n/g;

		 my @html = $self->readFile("Skins/$Libs::API::skin/news/AdmNewsBlock.html");

		 foreach my $line (@html)
		   {
			     $line =~ s/__DATE__/$t{'Date'}/eg;
			     $line =~ s/__TITLE__/$t{'Title'}/eg;
			     $line =~ s/__CONTENT__/$t{'Message'}/eg;
			     $line =~ s/__USER__/$t{'Name'}/eg;
			     $line =~ s/__MSGS__/$totalMSG/eg;
			     $line =~ s/__ID__/$i/eg;
			     $line =~ s/<!-- _1_ -->/$lang{'date'}/eg;
			     $line =~ s/<!-- _2_ --> /$lang{'nick'}/eg;

			  	$msgtmp .= $line;
	           }
		   			%_ = ();
     }

##############################################

     my $sth = $Libs::API::dbh->prepare("SELECT * FROM ${Libs::API::dbPrefix}_Module_Guest_Smiles");
           $sth->execute();

               while (my $ref = $sth->fetchrow_hashref())
	          {
                   $msgtmp =~ s/$ref->{'Smile'}/$ref->{'Code'}/eg;
                  }

           $sth->finish();

     $msgtmp .= "<br><center>$nPage</center>";

#######################

sub viewEmpty
{
     my @html = $self->readFile("Skins/$Libs::API::$skin/news/empty.html");

     foreach my $line (@html)
      {
        $msgtmp .= $line;
      }

   return $msgtmp;
}

#######################

return $msgtmp;
}

##############################################

sub saveEdit
{
  my $self = shift;
  my $id = $info{'idnum'};

    $info{'message'} =~ s/&gt;/>/g;
    $info{'message'} =~ s/&lt;/</g;

      $self->db_do_query("UPDATE ${Libs::API::dbPrefix}_Module_News_Data
    				     SET ID=$info{'id'}, Date=\"$info{'date'}\", Title=\"$info{'title'}\", Message=\"$info{'message'}\" WHERE ID=$id");

  return "<center><br><b> ...</b></center>";
}

##############################################

##############################################

sub delEdit
{
  my $self = shift;
  my $id = $info{'idnum'};

      $self->db_do_query("DELETE FROM ${Libs::API::dbPrefix}_Module_News_Data WHERE ID=$id");
      $self->db_do_query("DELETE FROM ${Libs::API::dbPrefix}_Module_Guest_Data WHERE ID=$id");

  return "<center><br><b> ...</b></center>";
}

##############################################

   return undef;
}

1;
