##############################
#
#       nX - Statistic
#         (Codename: XEN-Stats)
#            ver 0.2-dev
#
#     This script is a part of
#           XEN CMS
#
#     Writted by NeuroniX
#       aka Viguro Nikolay
#        neuronix666@yandex.ru
#
#         Started at 01/10/04
#
##############################

sub Stats
{
my ($self, %info) = @_;
my %cook = $self->getCookies();

my $globPrint;
my $month = $self->LocalDate("\%B");
my $year = $self->LocalDate("\%Y");

#eval 'use GD::Graph;';

        if($@)
          {
                print "<br><div align=center>
                        <h2> </h2><br>,   <b>GD::Graph</b>
                        <br>    .<br><br>$@</div>";

                return 1;
          }

#=============================================================

          return $self->viewStat(@Libs::API::Months[$info{'month'}], $info{'year'}) if $info{'month'} && $info{'year'};
          return $self->viewStat(@Libs::API::Months[0], $info{'year'}) if $info{'month'} == 0 && $info{'year'};
          return $self->viewStat($month, $year);

#=============================================================

sub viewStat
{
  my ($self, $month, $year) =@_;

    my %date = $self->db_get_hash_query("SELECT Date FROM ${Libs::API::dbPrefix}_Module_Stats_Browsers WHERE Date=\"$month $year\"",
                                                                "Date");
    %_ = ();

  my %b = $self->db_get_hash_query("SELECT * FROM ${Libs::API::dbPrefix}_Module_Stats_Browsers WHERE Date=\"$month $year\"",
                                                       "MSIE, Opera, Firefox, Netscape, Lynx, WebTV, Konqueror, Bot, Other");

  return "<br><center><b>   $month $year !</b></center>\n" if !$date{'Date'};

  my $totalRegUsers = $self->db_rows_count("SELECT * FROM ${Libs::API::dbPrefix}_Module_Users");

    my $totalBR = $b{'MSIE'}+$b{'Opera'}+$b{'Firefox'}+$b{'Netscape'}+$b{'Lynx'}+$b{'WebTV'}+$b{'Konqueror'}+$b{'Bot'}+$b{'Other'};

  %_ = ();

  my %os = $self->db_get_hash_query("SELECT * FROM ${Libs::API::dbPrefix}_Module_Stats_OS WHERE Date=\"$month $year\"",
                                                       "Windows, Linux, Mac, FreeBSD, IRIX, AIX, OS2, BeOS, SunOS, Other");

    my $totalOS = $os{'Windows'}+$os{'Linux'}+$os{'Mac'}+$os{'FreeBSD'}+$os{'IRIX'}+$os{'AIX'}+$os{'OS2'}+$os{'BeOS'}+$os{'SunOS'}+$os{'Other'};

  %_ = ();

  my %v = $self->db_get_hash_query("SELECT * FROM ${Libs::API::dbPrefix}_Module_Stats_Visits WHERE Date=\"$month $year\"",
                                                       "h02, h24, h46, h68, h810, h1012, h1214, h1416, h1618, h1820, h2022, h220");

  %_ = ();

  my $totalVI = $v{'h02'}+$v{'h24'}+$v{'h46'}+$v{'h68'}+$v{'h810'}+$v{'h1012'}+$v{'h1214'}+$v{'h1416'}+$v{'h1618'}+$v{'h1820'}+$v{'h2022'}+$v{'h220'};

  my @keys = keys %v;
  my @keysB = keys %b;
  my @keysOS = keys %os;

  my $val, $valB, $valOS;

  my $bestHour;
  my $badHour;

  my $bestB;
  my $bestOS;

  my $best_hitsOS;
  my $best_hitsB;

  my $bad = 0;
  my $best = 0;
  my $best_B = 0;
  my $best_OS = 0;

  my $currMonth;
  my $prevMonth;
  my $nextMonth;

 my $currYear = $self->LocalDate("\%Y");

 if(!$info{'month'} && !$info{'year'})
 {
        $currMonth = $self->LocalDate("\%m") - 1;
        $prevMonth = $currMonth - 1;
        $nextMonth = $self->LocalDate("\%m");
 }
 else
 {
        $currMonth = $info{'month'};
        $prevMonth = $info{'month'} - 1;
        $nextMonth = $info{'month'} + 1;
        $currYear = $info{'year'};
}

 my $nextYear = $currYear;

 if($nextMonth == 12) { $nextYear = $currYear + 1; $nextMonth = 0; }
 if($currMonth == 0) { $currYear = $currYear - 1; $prevMonth = 11; }

     foreach my $line (@keys)
     {
        $val = $v{$line};

         if ($val >= $best) # Best hours
          {
           $best = $val;
           if($line ne "h02" && $line ne "h24" && $line ne "h46" && $line ne "h68")
           { $line =~ /h(\d{2})(\d{2})/; $bestHour = "$1:00 - $2:00"; }
            else
           { $line =~ /h(\d{1})(\d{1})/; $bestHour = "$1:00 - $2:00"; }
            if ($line eq "h810") { $line =~ /h(\d{1})(\d{2})/; $bestHour = "$1:00 - $2:00"; }
            if ($line eq "h220") { $line =~ /h(\d{2})(\d{1})/; $bestHour = "$1:00 - $2:00"; }
          }
      }

        $bad= $best;

     foreach my $line (@keys)
     {
        $val = $v{$line};

         if ($val <= $bad) # Bad hours
          {
           $bad = $val;
           if($line ne "h02" && $line ne "h24" && $line ne "h46" && $line ne "h68")
           { $line =~ /h(\d{2})(\d{2})/; $badHour = "$1:00 - $2:00"; }
            else
           { $line =~ /h(\d{1})(\d{1})/; $badHour = "$1:00 - $2:00"; }

            if ($line eq "h810") { $line =~ /h(\d{1})(\d{2})/; $badHour = "$1:00 - $2:00"; }
            if ($line eq "h220") { $line =~ /h(\d{2})(\d{1})/; $badHour = "$1:00 - $2:00"; }
          }
     }

  my %brPers;
  my %osPers;
  my %viPers;

            $brPers{'MSIE'} = int 100*$b{'MSIE'}/$totalBR;
            $brPers{'Opera'} = int 100*$b{'Opera'}/$totalBR;
            $brPers{'Firefox'} = int 100*$b{'Firefox'}/$totalBR;
            $brPers{'Netscape'} = int 100*$b{'Netscape'}/$totalBR;
            $brPers{'Lynx'} = int 100*$b{'Lynx'}/$totalBR;
            $brPers{'WebTV'} = int 100*$b{'WebTV'}/$totalBR;
            $brPers{'Konqueror'} = int 100*$b{'Konqueror'}/$totalBR;
            $brPers{'Bot'} = int 100*$b{'Bot'}/$totalBR;
            $brPers{'Other'} = int 100*$b{'Other'}/$totalBR;

            $osPers{'Windows'} = int 100*$os{'Windows'}/$totalOS;
            $osPers{'Linux'} = int 100*$os{'Linux'}/$totalOS;
            $osPers{'Mac'} = int 100*$os{'Mac'}/$totalOS;
            $osPers{'AIX'} = int 100*$os{'AIX'}/$totalOS;
            $osPers{'IRIX'} = int 100*$os{'IRIX'}/$totalOS;
            $osPers{'FreeBSD'} = int 100*$os{'FreeBSD'}/$totalOS;
            $osPers{'OS2'} = int 100*$os{'OS2'}/$totalOS;
            $osPers{'BeOS'} = int 100*$os{'BeOS'}/$totalOS;
            $osPers{'SunOS'} = int 100*$os{'SunOS'}/$totalOS;
            $osPers{'Other'} = int 100*$os{'Other'}/$totalOS;

            $viPers{'h02'} = int 100*$v{'h02'}/$totalVI;
            $viPers{'h24'} = int 100*$v{'h24'}/$totalVI;
            $viPers{'h46'} = int 100*$v{'h46'}/$totalVI;
            $viPers{'h68'} = int 100*$v{'h68'}/$totalVI;
            $viPers{'h810'} = int 100*$v{'h810'}/$totalVI;
            $viPers{'h1012'} = int 100*$v{'h1012'}/$totalVI;
            $viPers{'h1214'} = int 100*$v{'h1214'}/$totalVI;
            $viPers{'h1416'} = int 100*$v{'h1416'}/$totalVI;
            $viPers{'h1618'} = int 100*$v{'h1618'}/$totalVI;
            $viPers{'h1820'} = int 100*$v{'h1820'}/$totalVI;
            $viPers{'h2022'} = int 100*$v{'h2022'}/$totalVI;
            $viPers{'h220'} = int 100*$v{'h220'}/$totalVI;

                        $brPers{'MSIE2'} = setBars($brPers{'MSIE'}); # Draw image bars in HTML
                        $brPers{'Opera2'} = setBars($brPers{'Opera'});
                        $brPers{'Firefox2'} = setBars($brPers{'Firefox'});
                        $brPers{'Netscape2'} = setBars($brPers{'Netscape'});
                        $brPers{'Lynx2'} = setBars($brPers{'Lynx'});
                        $brPers{'WebTV2'} = setBars($brPers{'WebTV'});
                        $brPers{'Konqueror2'} = setBars($brPers{'Konqueror'});
                        $brPers{'Bot2'} = setBars($brPers{'Bot'});
                        $brPers{'Other2'} = setBars($brPers{'Other'});

                        $osPers{'Windows2'} = setBars($osPers{'Windows'}); # Draw image bars in HTML
                        $osPers{'Linux2'} = setBars($osPers{'Linux'});
                        $osPers{'Mac2'} = setBars($osPers{'Mac'});
                        $osPers{'AIX2'} = setBars($osPers{'AIX'});
                        $osPers{'IRIX2'} = setBars($osPers{'IRIX'});
                        $osPers{'FreeBSD2'} = setBars($osPers{'FreeBSD'});
                        $osPers{'OS22'} = setBars($osPers{'OS2'});
                        $osPers{'BeOS2'} = setBars($osPers{'BeOS'});
                        $osPers{'SunOS2'} = setBars($osPers{'SunOS'});
                        $osPers{'Other2'} = setBars($osPers{'Other'});

                        $viPers{'h02b'} = setBars($viPers{'h02'}); # Draw image bars in HTML
                        $viPers{'h24b'} = setBars($viPers{'h24'});
                        $viPers{'h46b'} = setBars($viPers{'h46'});
                        $viPers{'h68b'} = setBars($viPers{'h68'});
                        $viPers{'h810b'} = setBars($viPers{'h810'});
                        $viPers{'h1012b'} = setBars($viPers{'h1012'});
                        $viPers{'h1214b'} = setBars($viPers{'h1214'});
                        $viPers{'h1416b'} = setBars($viPers{'h1416'});
                        $viPers{'h1618b'} = setBars($viPers{'h1618'});
                        $viPers{'h1820b'} = setBars($viPers{'h1820'});
                        $viPers{'h2022b'} = setBars($viPers{'h2022'});
                        $viPers{'h220b'} = setBars($viPers{'h220'});

     foreach my $line (@keysB)
     {
        $valB = $b{$line};

         if ($valB >= $best_hitsB) # Best browser
          {
           $best_B = $line; # Name
           $bestB = $brPers{$line}; # Persent
           $best_hitsB = $valB;
          }
     }

     foreach my $line (@keysOS)
     {
        $valOS = $os{$line};

         if ($valOS >= $best_hitsOS) # Best OS
          {
           $best_OS = $line; # Name
           $bestOS = $osPers{$line}; # Persent
           $best_hitsOS = $valOS;
          }
     }

            my @html = $self->readFile("Skins/$Libs::API::skin/stats/Main.html");
                foreach my $line (@html)
                {
                        $line =~ s/__MSIE__/$b{'MSIE'}/g;
                        $line =~ s/__OPERA__/$b{'Opera'}/g;
                        $line =~ s/__FIREFOX__/$b{'Firefox'}/g;
                        $line =~ s/__NETSCAPE__/$b{'Netscape'}/g;
                        $line =~ s/__LYNX__/$b{'Lynx'}/g;
                        $line =~ s/__WEBTV__/$b{'WebTV'}/g;
                        $line =~ s/__KONQUEROR__/$b{'Konqueror'}/g;
                        $line =~ s/__BOT__/$b{'Bot'}/g;
                        $line =~ s/__OTHER__/$b{'Other'}/g;

                        $line =~ s/__MSIE_P__/$brPers{'MSIE2'}/g; # Draw image bars in HTML
                        $line =~ s/__OPERA_P__/$brPers{'Opera2'}/g;
                        $line =~ s/__FIREFOX_P__/$brPers{'Firefox2'}/g;
                        $line =~ s/__NETSCAPE_P__/$brPers{'Netscape2'}/g;
                        $line =~ s/__LYNX_P__/$brPers{'Lynx2'}/g;
                        $line =~ s/__WEBTV_P__/$brPers{'WebTV2'}/g;
                        $line =~ s/__KONQUEROR_P__/$brPers{'Konqueror2'}/g;
                        $line =~ s/__BOT_P__/$brPers{'Bot2'}/g;
                        $line =~ s/__OTHER_P__/$brPers{'Other2'}/g;

                        $line =~ s/__MSIE_PE__/$brPers{'MSIE'}/g; #  in HTML
                        $line =~ s/__OPERA_PE__/$brPers{'Opera'}/g;
                        $line =~ s/__FIREFOX_PE__/$brPers{'Firefox'}/g;
                        $line =~ s/__NETSCAPE_PE__/$brPers{'Netscape'}/g;
                        $line =~ s/__LYNX_PE__/$brPers{'Lynx'}/g;
                        $line =~ s/__WEBTV_PE__/$brPers{'WebTV'}/g;
                        $line =~ s/__KONQUEROR_PE__/$brPers{'Konqueror'}/g;
                        $line =~ s/__BOT_PE__/$brPers{'Bot'}/g;
                        $line =~ s/__OTHER_PE__/$brPers{'Other'}/g;

                        $line =~ s/__WINDOWS__/$os{'Windows'}/g;
                        $line =~ s/__LINUX__/$os{'Linux'}/g;
                        $line =~ s/__FREEBSD__/$os{'FreeBSD'}/g;
                        $line =~ s/__AIX__/$os{'AIX'}/g;
                        $line =~ s/__IRIX__/$os{'IRIX'}/g;
                        $line =~ s/__MAC__/$os{'Mac'}/g;
                        $line =~ s/__OS2__/$os{'OS2'}/g;
                        $line =~ s/__BEOS__/$os{'BeOS'}/g;
                        $line =~ s/__SUNOS__/$os{'SunOS'}/g;
                        $line =~ s/__OTHER__/$os{'Other'}/g;

                        $line =~ s/__WINDOWS_P__/$osPers{'Windows2'}/g;
                        $line =~ s/__LINUX_P__/$osPers{'Linux2'}/g;
                        $line =~ s/__FREEBSD_P__/$osPers{'FreeBSD2'}/g;
                        $line =~ s/__AIX_P__/$osPers{'AIX2'}/g;
                        $line =~ s/__IRIX_P__/$osPers{'IRIX2'}/g;
                        $line =~ s/__MAC_P__/$osPers{'Mac2'}/g;
                        $line =~ s/__OS2_P__/$osPers{'OS22'}/g;
                        $line =~ s/__BEOS_P__/$osPers{'BeOS2'}/g;
                        $line =~ s/__SUNOS_P__/$osPers{'SunOS2'}/g;
                        $line =~ s/__OTHER_P__/$osPers{'Other2'}/g;

                        $line =~ s/__WINDOWS_PE__/$osPers{'Windows'}/g;
                        $line =~ s/__LINUX_PE__/$osPers{'Linux'}/g;
                        $line =~ s/__FREEBSD_PE__/$osPers{'FreeBSD'}/g;
                        $line =~ s/__AIX_PE__/$osPers{'AIX'}/g;
                        $line =~ s/__IRIX_PE__/$osPers{'IRIX'}/g;
                        $line =~ s/__MAC_PE__/$osPers{'Mac'}/g;
                        $line =~ s/__OS2_PE__/$osPers{'OS2'}/g;
                        $line =~ s/__BEOS_PE__/$osPers{'BeOS'}/g;
                        $line =~ s/__SUNOS_PE__/$osPers{'SunOS'}/g;
                        $line =~ s/__OTHER_PE__/$osPers{'Other'}/g;


                        $line =~ s/__H02__/$v{'h02'}/g;
                        $line =~ s/__H24__/$v{'h24'}/g;
                        $line =~ s/__H46__/$v{'h46'}/g;
                        $line =~ s/__H68__/$v{'h68'}/g;
                        $line =~ s/__H810__/$v{'h810'}/g;
                        $line =~ s/__H1012__/$v{'h1012'}/g;
                        $line =~ s/__H1214__/$v{'h1214'}/g;
                        $line =~ s/__H1416__/$v{'h1416'}/g;
                        $line =~ s/__H1618__/$v{'h1618'}/g;
                        $line =~ s/__H1820__/$v{'h1820'}/g;
                        $line =~ s/__H2022__/$v{'h2022'}/g;
                        $line =~ s/__H220__/$v{'h220'}/g;

                        $line =~ s/__H02_P__/$viPers{'h02b'}/g;
                        $line =~ s/__H24_P__/$viPers{'h24b'}/g;
                        $line =~ s/__H46_P__/$viPers{'h46b'}/g;
                        $line =~ s/__H68_P__/$viPers{'h68b'}/g;
                        $line =~ s/__H810_P__/$viPers{'h810b'}/g;
                        $line =~ s/__H1012_P__/$viPers{'h1012b'}/g;
                        $line =~ s/__H1214_P__/$viPers{'h1214b'}/g;
                        $line =~ s/__H1416_P__/$viPers{'h1416b'}/g;
                        $line =~ s/__H1618_P__/$viPers{'h1618b'}/g;
                        $line =~ s/__H1820_P__/$viPers{'h1820b'}/g;
                        $line =~ s/__H2022_P__/$viPers{'h2022b'}/g;
                        $line =~ s/__H220_P__/$viPers{'h220b'}/g;

                        $line =~ s/__H02_PE__/$viPers{'h02'}/g;
                        $line =~ s/__H24_PE__/$viPers{'h24'}/g;
                        $line =~ s/__H46_PE__/$viPers{'h46'}/g;
                        $line =~ s/__H68_PE__/$viPers{'h68'}/g;
                        $line =~ s/__H810_PE__/$viPers{'h810'}/g;
                        $line =~ s/__H1012_PE__/$viPers{'h1012'}/g;
                        $line =~ s/__H1214_PE__/$viPers{'h1214'}/g;
                        $line =~ s/__H1416_PE__/$viPers{'h1416'}/g;
                        $line =~ s/__H1618_PE__/$viPers{'h1618'}/g;
                        $line =~ s/__H1820_PE__/$viPers{'h1820'}/g;
                        $line =~ s/__H2022_PE__/$viPers{'h2022'}/g;
                        $line =~ s/__H220_PE__/$viPers{'h220'}/g;

                        $line =~ s/__BEST_OS__/$best_OS/g;
                        $line =~ s/__BEST_OS_PERS__/$bestOS/g;
                        $line =~ s/__BEST_OS_HITS__/$best_hitsOS/g;

                        $line =~ s/__BEST_BROWSER__/$best_B/g;
                        $line =~ s/__BEST_BROWSER_PERS__/$bestB/g;
                        $line =~ s/__BEST_BROWSER_HITS__/$best_hitsB/g;

                        $line =~ s/__YEAR__/$currYear/g;
                        $line =~ s/__NEXT_YEAR__/$nextYear/g;
                        $line =~ s/__NEXT_MONTH__/$nextMonth/g;
                        $line =~ s/__PREV_MONTH__/$prevMonth/g;

                        $line =~ s/__TOTAL_VISITS__/$totalVI/g;

                        $line =~ s/__BEST_HITS__/$best/g;
                        $line =~ s/__BEST_HOUR__/$bestHour/g;

                        $line =~ s/__BAD_HITS__/$bad/g;
                        $line =~ s/__BAD_HOUR__/$badHour/g;

                        $line =~ s/__DATE__/$date{'Date'}/g;
                        $line =~ s/__TOTAL_REGISTRED_USERS__/$totalRegUsers/g;

                        $line =~ s/__XEN_VERSION__/$Libs::API::VERSION/g;
                        $line =~ s/__THEME__/$Libs::API::skin/g;

                        $globPrint .= $line;
                }

        return $globPrint;
}

sub setBars
{
  my $pers = shift;
  my $tmp;
  my $bar;

if($pers != 0)
 {
     my $width = $pers*2+5;
     $bar .= "<img src=\"/Images/votes/leftbar.gif\" height=\"15\" width=\"7\" alt=\"$pers \%\"><img src=\"/Images/votes/mainbar2.gif\" height=\"15\" width=\"$width\" alt=\"$pers \%\"><img src=\"/Images/votes/rightbar.gif\" height=\"15\" width=\"7\" alt=\"$pers \%\">&nbsp;\n";
 }
 else
 {
     $bar .= "<img src=\"/Images/votes/leftbar.gif\" height=\"15\" width=\"7\" alt=\"0 \%\"><img src=\"/Images/votes/mainbar2.gif\" height=\"15\" width=\"5\" alt=\"0 %\"><img src=\"/Images/votes/rightbar.gif\" height=\"15\" width=\"7\" alt=\"0 \%\">&nbsp;\n";
 }

  return $bar;
}

        return $globPrint;
}

1;
