##############################
#
#       nX - UserInfo
#         (Codename: XEN-Users)
#
#     This script is a part of
#           XEN CMS
#
#     Writted by NeuroniX
#       aka Viguro Nikolay
#        neuronix666@yandex.ru
#
#         Started at 15/02/04
#
##############################

#--------------- Initialize ----------------#

sub UserInfoAdmin
{
  my ($self, %info) = @_;
  my $center;
  my $cnt;
  my $total;

        our $ADI = new Libs::ADI ( initMods => 1,
                                               readConf => 1 ); # Initalize ADI constructor


  return $self->editUser() if $info{'action'} eq 'edit';
  return $self->saveUser() if $info{'action'} eq 'save';
  return $self->delUser($info{'user'}) if $info{'action'} eq 'del';

  #------------------     ---------------#
  #### (26.11.04 Nix) ####

  return $self->chgUserStatus($info{'user'}, 1) if $info{'action'} eq 'admin' && $self->isUserAdmin();
  return $self->chgUserStatus($info{'user'}, 2) if $info{'action'} eq 'moder' && $self->isUserAdmin();
  return $self->chgUserStatus($info{'user'}, 3) if $info{'action'} eq 'user' && $self->isUserAdmin();

  #---------------------------------------------------------------------------------------------------#

  return $self->viewAllUsers();

#===================================
#===================================

sub editUser
{
  my $self = shift;

   $self->db_get_hash_query("SELECT * FROM ${Libs::API::dbPrefix}_Module_Users
                                            WHERE UserName=\"$info{'user'}\"",
"UserName, Password, Level, FIO, City, Country, EMail, About, Level, HomeURL, ICQ, NewsAdded, StoryAdded, SurveysAdded, GuestAdded, FilesAdded, Avatar");

   $_{'ICQ'} = "" if $_{'ICQ'} == 0;

   my $avatars = $self->readAvatars($info{'user'});

  my @html = $self->readFile("Skins/$Libs::API::$skin/userinfo/ProfileAdmin.html");

                 foreach my $line (@html)
                   {
                             $line =~ s/__EMAIL__/$_{'EMail'}/eg;
                             $line =~ s/__HOME__/$_{'HomeURL'}/eg;
                             $line =~ s/__LEVEL__/$_{'Level'}/eg;
                             $line =~ s/__AVATARS__/$avatars/eg;
                             $line =~ s/__OLDAVATAR__/$_{'Avatar'}/eg;
                             $line =~ s/__FIO__/$_{'FIO'}/eg;
                             $line =~ s/__CITY__/$_{'City'}/eg;
                             $line =~ s/__COUNTRY__/$_{'Country'}/eg;
                             $line =~ s/__ICQ__/$_{'ICQ'}/eg;
                             $line =~ s/__LEVEL__/$_{'Level'}/eg;
                             $line =~ s/__USERNAME__/$_{'UserName'}/eg;
                             $line =~ s/__PASSWORD__/$_{'Password'}/eg;
                             $line =~ s/__ABOUT__/$_{'About'}/eg;
                             $line =~ s/__NEWS__/$_{'NewsAdded'}/eg;
                             $line =~ s/__STORY__/$_{'StoryAdded'}/eg;
                             $line =~ s/__SURVEYS__/$_{'SurveysAdded'}/eg;
                             $line =~ s/__GUEST__/$_{'GuestAdded'}/eg;
                             $line =~ s/__FILES__/$_{'FilesAdded'}/eg;
                             $line =~ s/__TOTAL__/$total/eg;


                                $center .= $line;
                   }

   return $center;
}

#===================================
#===================================

sub saveUser
{
  my $self = shift;
  my $newPass;
  my $isNewPass;
  my $avatar = "/Images/avatars/$info{'avatar'}";

   $self->db_get_hash_query("SELECT * FROM ${Libs::API::dbPrefix}_Module_Users
                                            WHERE UserName=\"$info{'user'}\"",
        "UserName, Password, FIO, City, Country, EMail, About, Level, HomeURL, ICQ, NewsAdded, StoryAdded, SurveysAdded, GuestAdded, FilesAdded");

   print "Location: main.cgi\n\n" if $info{'oldpasswd'} ne $_{'Password'}; # Protection

   if($info{'icq'}) { print "Location: main.cgi\n\n" if $info{'icq'} !~ /\d+/; }
   if($info{'email'}) { print "Location: main.cgi\n\n" if $info{'email'} !~ /.*?\@.*?\..*/; }

    if($info{'passwd'})
      { $newPass = $self->genMD5($info{'passwd'}); $isNewPass = 1;  } else { $newPass = $info{'oldpasswd'}; }

    $info{'news'} = $_{'NewsAdded'} if $info{'news'} eq ""; #    .
    $info{'story'} = $_{'StoryAdded'} if $info{'story'} eq "";
    $info{'polls'} = $_{'SurveysAdded'} if $info{'polls'} eq "";
    $info{'guest'} = $_{'GuestAdded'} if $info{'guest'} eq "";
    $info{'files'} = $_{'FilesAdded'} if $info{'files'} eq "";
    $info{'level'} = $_{'Level'} if $info{'level'} eq "";

    $self->db_do_query("UPDATE ${Libs::API::dbPrefix}_Module_Users
                                   SET Password=\"$newPass\",
                                           Level=\"$info{'level'}\",
                                           FIO=\"$info{'fio'}\",
                                           City=\"$info{'city'}\",
                                           Country=\"$info{'country'}\",
                                           EMail=\"$info{'email'}\",
                                           About=\"$info{'about'}\",
                                           HomeURL=\"$info{'home'}\",
                                           ICQ=\"$info{'icq'}\",
                                           Avatar=\"$avatar\",
                                           NewsAdded=\"$info{'news'}\",
                                           StoryAdded=\"$info{'story'}\",
                                           SurveysAdded=\"$info{'polls'}\",
                                           GuestAdded=\"$info{'guest'}\",
                                           FilesAdded=\"$info{'files'}\"
                                    WHERE UserName=\"$info{'user'}\"");

   $ADI->printPage("<br><center><b> ...</b></center>");
}
#===================================
#===================================

   return $center;
}

sub delUser
{
  my ($self, $user) = @_;

    $self->db_do_query("DELETE FROM ${Libs::API::dbPrefix}_Module_Users WHERE UserName=\"$user\"");

   $ADI->printPage($self->printBlock(" !", "<br><center> <b>$user</b> ...</center>"));
}
#===================================
#===================================

sub viewAllUsers
{
  my $self = shift;

     my $center = "<br><table style=\"width: 90%; background-color: rgb(0, 0, 0);\" border=0 cellspacing=1 cellpadding=3>
                           <tbody>
                            <tr>
                              <td colspan=2 class=headline align=center> [ ::  :: ]</td>
                            </tr>";

            my $sth = $Libs::API::dbh->prepare("SELECT * FROM ${Libs::API::dbPrefix}_Module_Users ORDER BY UserName ASC");
                  $sth->execute();

               while (my $ref = $sth->fetchrow_hashref())
                  {
                    my @html = $self->readFile("Skins/$Libs::API::$skin/userinfo/AllUsersAdmin.html");

                    foreach my $line (@html)
                     {
                             $line =~ s/__PAGE__/$page/eg;
                             $line =~ s/__USERNAME__/$ref->{'UserName'}/eg;

                                $center .= $line;
                     }

                     %_ = ();
                  }

           $sth->finish();

   $center .= "</tbody></table><br>\n";

   #==========================

    $ADI->printPage($center);
}

#===================================
#===================================

sub chgUserStatus
{
    my ($self, $user, $status) = @_;

    if($status == 1)
    {

    }
    elsif($status == 2)
    {

    }
    else
    {

    }

    $ADI->printPage($center);
}

#===================================
#===================================

1;
