#!/usr/bin/perl

#####################################

=head1 COPYRIGHT

  Copyright Notice
  ================

  Copyright 2004 Neuronix

  Copying Permission
  ------------------

  This script is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

  ********************************************************************

=head1 INFO

  Script Info
  ===========

  Author        : Neuronix
                     aka Nikolay Viguro

  Project       : nX - Engine (Codename: XEN)
                     This is CMS engine, writted on Perl language.

  Script        : admin.cgi
                    Administration interface script.

  Started      : 19/01/2004

=cut

#########################################

use strict;
use Libs::ADI;

#########################################

our $ADI = new Libs::ADI ( initMods => 1,
                                         readConf => 1 ); # Initalize ADI constructor

our $API = new Libs::API ( readConf => 1 ); # Initalize API constructor

#########################################

our %config = %Libs::ADI::config;
our %info = %Libs::ADI::info;
our %cook = %Libs::ADI::cook;

#########################################
#########################################

onModulesConfig(1) if $info{'act'} ne "" && $info{'do'} eq "Modules"
                             && $API->isUserValid() && $ADI->isUserAccess("ModulesConfig", $cook{'login'});

onConfig(1) if $info{'action'} eq "changeconfig" && $API->isUserAdmin($cook{'login'})
                 && $API->isUserValid() && $ADI->isUserAccess("onConfig", $cook{'login'});

delOnConfig($info{'del'}) if $info{'do'} eq "Config" && $info{'del'} ne ""
                                  && $API->isUserValid() && $ADI->isUserAccess("onConfig", $cook{'login'});

onModule($info{'do'}) if defined $info{'do'} && $API->isUserValid()
                              && $ADI->isUserAccess($info{'do'}, $cook{'login'});

$ADI->Jump("action=main", "+1h") if $info{'action'} eq "enter" && $ADI->isUserAccess("onMain", $info{'login'});

$ADI->Jump("", "-1h") if $info{'action'} eq "logout";

onMain() if $cook{'login'} ne "" && $cook{'passwd'} ne "" && $API->isUserValid() && $ADI->isUserAccess("onMain", $cook{'login'});

$ADI->Login(); #    ,    .

#########################################
#########################################

sub onModule
{
    my $module = shift;
    my $center;
    my $callname = "${module}Admin";

    onConfig() if $module eq "Config";
    onModulesConfig() if $module eq "Modules";

    $API->singleInit($module, 1);
    eval '$center = $API->$callname(%info);';
    $center = "<br><div align=center><b>,    $module<br> admin-.</b><br><br>$@</div>" if $@;

    $ADI->printPage($center);
}

#########################################
#########################################

sub onMain
{
    my %mods;
    my %imgs;
    my $cnt;
    my $center = "<h3> , $cook{'login'} !</h3>";
          $center .= "<br><table align=left border=0 cellspacing=0 cellpadding=0><tr>\n";

     # Connecting to DB.

     my $sth = $Libs::API::dbh->prepare("SELECT * FROM ${Libs::API::dbPrefix}_Admin_MainMenu");
           $sth->execute();

               while (my $ref = $sth->fetchrow_hashref())
                 {
                    $mods{$ref->{'Name'}} = $ref->{'Link'};
                    $imgs{$ref->{'Name'}} = $ref->{'Image'};
                  }

           $sth->finish();

     # Disconnecting from DB.

    my @keys = keys %mods;
    my @values = values %mods;

         while (@keys)
          {
             my $keys = pop(@keys);
             my $vals = pop(@values);

             $center .= "<td width=100 align=center><div><a href=\"$vals\" title=\"$keys\">
                              <img border=0 width=32 height=32 src=\"/Skins/$Libs::API::skin/images/admin/$imgs{$keys}\"><br><br>$keys</img></a></div></td>\n";
             $cnt++;

             if($cnt == 5) { $center .= "</tr><tr><td colspan=5>&nbsp;<br></td></tr><tr>\n"; }
          }

   $center .= "</tr></table>\n";

    $ADI->printPage($center);

}

#########################################
#########################################

sub onConfig
{
   my $action = shift;

   chgConf() if $action;

   ##########################

       my $center = "<h3><div class=adminhead>::  ::</div></font></h3><br>
                             <table bgcolor=black width=100% align=left border=0 cellspacing=1 cellpadding=2>\n
                             <tr><td class=headline colspan=5 align=center><font size=4 color=white> </font></td></tr>
                             <form action=admin.cgi method=POST>\n
                             <input type=hidden name=action value=changeconfig>\n";

                my @keys = keys %config;
                my @values = values %config;

                   while (@keys)
                    {
                       my $keys = pop(@keys);
                       my $vals = pop(@values);

                       $API->db_get_hash_query("SELECT IsUserDef FROM ${Libs::API::dbPrefix}_Config WHERE Name=\"$keys\"","IsUserDef");

                        $center .= "<tr><td class=headline width=15% align=center>$keys:</td>\n
                                            <td width=35% class=textbg align=center><font color=white>
                                            <input style=\"width: 300\" type=text name=$keys value=\"$vals\"></font>";
                        $center .= " <a href=admin.cgi?do=Config&del=$keys><img border=0 src=/Images/admin/del.png></a>" if $_{'IsUserDef'};
                        $center .= "</td></tr>\n";
                    }

       $center .= "<tr><td class=headline width=15% align=center><input type=text name=newkey></td>\n
                        <td width=35% class=textbg align=center><font color=white>
                        <input style=\"width: 300\" type=text name=newvar></font></td></tr>\n";
        $center .= "<tr><td class=headline colspan=2 align=center><input type=submit value=></td></tr></form></table>\n";

        $ADI->printPage($center);

     #######################

    sub chgConf
    {
     my $sth = $Libs::API::dbh->prepare("SELECT * FROM ${Libs::API::dbPrefix}_Config");
           $sth->execute();

                     while (my $ref = $sth->fetchrow_hashref())
                       {
                           my @keys = keys %config;
                           my @values = values %config;

                           while (@keys)
                              {
                                 my $keys = pop(@keys);
                                 my $vals = pop(@values);

                                     if(defined $ref->{'Param'} && $keys eq $ref->{'Name'})
                                      {
                                       if($info{$keys} ne $ref->{'Param'})
                                        {
                                         $API->db_do_query("UPDATE ${Libs::API::dbPrefix}_Config SET Param=\"$info{$keys}\" WHERE Name=\"$keys\"");
                                         $config{$keys} = $info{$keys}; # Updating config info.
                                        }
                                      }
                                     if(!defined $ref->{'Param'} && $keys eq $ref->{'Name'})
                                      {
                                        $API->db_do_query("INSERT INTO ${Libs::API::dbPrefix}_Config VALUES (\"$keys\", \"$info{$keys}\", 0)");
                                        $config{$keys} = $info{$keys}; # Updating config info.
                                      }
                               }
                         }

           if($info{'newkey'})
             {
                 $API->db_do_query("INSERT INTO ${Libs::API::dbPrefix}_Config VALUES (\"$info{'newkey'}\", \"$info{'newvar'}\", 1)");
                 $config{$info{'newkey'}} = $info{'newvar'}; # Updating config info.
             }

           $sth->finish();

   onConfig();

    }
}

sub delOnConfig
{
  my $del = shift;

    $API->db_do_query("DELETE FROM ${Libs::API::dbPrefix}_Config WHERE Name=\"$del\"");
    $ADI->printPage("<br>".$API->printBlock(" !", "<br><center> <b>$del</b>      !</center>"));
}

#########################################
#########################################

sub onModulesConfig
{
   my $action = shift;
   chgMods() if $action;
   viewMods();

   ###################

   sub viewMods
   {

   my $center = "<h3><div class=adminhead>::   ::</div></h3>\n";

         $center .= viewSide("Left");
         $center .= viewSide("Center");
         $center .= viewSide("Right");

         $center .= viewAll();

         $center .= "<br>\n";

   ######################################

   sub viewSide
   {
    my $side = shift;

    my $on;
    my $onIndex;
    my $isLoad;

    my $globPrint = "<br><table width=650 align=center border=0 cellspacing=0 cellpadding=3><tr>\n";
          $globPrint .= "<tr><td class=headline colspan=7 align=center><font size=4 color=white>Modules on $side side</font></td></tr>\n";
          $globPrint .= "<tr><td class=headline align=center><b></b></td>
                                <td class=headline align=center><b></b></td>
                                <td class=headline align=center><b></b></td>
                                <td class=headline align=center><b></b></td>
                                <td class=headline align=center><b></b></td>
                                <td class=headline align=center><b> </b></td>
                                <td class=headline align=center><b></b></td>
                               </tr>\n";

     # Connecting to DB.

     my $sth = $Libs::API::dbh->prepare("SELECT * FROM ${Libs::API::dbPrefix}_${side}Block ORDER BY Position ASC");
           $sth->execute();

           my $cntM;

               while (my $ref = $sth->fetchrow_hashref())
                 {
                    my $up = $ref->{'Position'}+1;
                    my $down = $ref->{'Position'}-1;

                    $cntM++;

                    $API->db_get_hash_query("SELECT Date, Active, Type FROM ${Libs::API::dbPrefix}_Modules WHERE BlockName=\"$ref->{'BlockName'}\"
                                                             ORDER BY \"Position\" ASC","Date, Active, Type") if $ref->{'Type'} eq "Mod";

                    $API->db_get_hash_query("SELECT Date, Active, Type FROM ${Libs::API::dbPrefix}_Blocks WHERE BlockName=\"$ref->{'BlockName'}\"
                                                           ","Date, Active, Type") if $ref->{'Type'} eq "Block";

                    if($_{'Active'})
                     {
                      $on = "<a href=\"admin.cgi?do=Modules&act=off&name=$ref->{'BlockName'}\"><font color=darkred></font></a>"
                                if $ref->{'Type'} eq "Mod";
                      $on = "<a href=\"admin.cgi?do=Modules&act=off&type=block&name=$ref->{'BlockName'}\"><font color=darkred></font></a>"
                                if $ref->{'Type'} eq "Block";
                      }
                    else
                     {
                      $on = "<a href=\"admin.cgi?do=Modules&act=on&name=$ref->{'BlockName'}\"><font color=darkgreen></font></a>"
                                if $ref->{'Type'} eq "Mod";
                      $on = "<a href=\"admin.cgi?do=Modules&act=on&type=block&name=$ref->{'BlockName'}\"><font color=darkgreen></font></a>"
                                if $ref->{'Type'} eq "Block";
                     }

                    $API->db_get_hash_query("SELECT OnIndex FROM ${Libs::API::dbPrefix}_${side}Block WHERE BlockName=\"$ref->{'BlockName'}\"","OnIndex");

                    if($_{'OnIndex'})
                     {
                     $onIndex = "<a href=\"admin.cgi?do=Modules&act=offIndex&side=$side&name=$ref->{'BlockName'}\"> </a>" if $ref->{'Type'} ne "Block";
                     $onIndex = "<a href=\"admin.cgi?do=Modules&act=offIndex&side=$side&type=block&name=$ref->{'BlockName'}\"> </a>"
                         if $ref->{'Type'} eq "Block";
                      }
                    else
                     {
                     $onIndex = "<a href=\"admin.cgi?do=Modules&act=onIndex&side=$side&name=$ref->{'BlockName'}\"> </a>" if $ref->{'Type'} ne "Block";
                     $onIndex = "<a href=\"admin.cgi?do=Modules&act=onIndex&side=$side&type=block&name=$ref->{'BlockName'}\"> </a>"
                        if $ref->{'Type'} eq "Block";
                      }

                    $globPrint .= "<tr><td class=textbg align=center>";

                    $globPrint .= " <a href=\"admin.cgi?do=Modules&act=chgSide&m=$ref->{'BlockName'}&fside=$side&tside=Left\"><img border=0 src=\"/Images/admin/left.gif\"></a> "
                                    if $side eq "Center";
                    $globPrint .= " <a href=\"admin.cgi?do=Modules&act=chgSide&m=$ref->{'BlockName'}&fside=$side&tside=Center\"><img border=0 src=\"/Images/admin/left.gif\"></a> "
                                    if $side eq "Right";

                    $globPrint .= " <a href=\"admin.cgi?do=Modules&act=chgPos&side=$side&from=$ref->{'Position'}&to=$up\"><img border=0 src=\"/Images/admin/down.gif\"></a>&nbsp;&nbsp;";
                    $globPrint .= "<a href=\"admin.cgi?do=Modules&act=chgPos&side=$side&from=$ref->{'Position'}&to=$down\">" if $down > 0;
                    $globPrint .= "<img border=0 src=\"/Images/admin/up.gif\"></a>" if $down > 0;

                    $globPrint .= " <a href=\"admin.cgi?do=Modules&act=chgSide&m=$ref->{'BlockName'}&fside=$side&tside=Right\"><img border=0 src=\"/Images/admin/right.gif\"> </a>"
                                   if $side eq "Center";
                    $globPrint .= "<a href=\"admin.cgi?do=Modules&act=chgSide&m=$ref->{'BlockName'}&fside=$side&tside=Center\"><img border=0 src=\"/Images/admin/right.gif\"> </a>"
                                   if $side eq "Left";

                    $globPrint .= "</td>
                                         <td class=textbg align=center>$_{'Date'}</td>";
                    $globPrint .= "<td class=textbg align=center></td>" if $ref->{'Type'} eq "Mod";
                    $globPrint .= "<td class=textbg align=center></td>" if $ref->{'Type'} eq "Block";
                    $globPrint .= "<td class=textbg align=center><a href=\"admin.cgi?do=Blocks\">$ref->{'BlockName'}</a></td>" if $ref->{'Type'} eq "Block";
                    $globPrint .= "<td class=textbg align=center><a href=\"admin.cgi?do=$ref->{'BlockName'}\">$ref->{'BlockName'}</a></td>" if $ref->{'Type'} eq "Mod";
                    $globPrint .= "<td class=textbg align=center>$on</td>
                                         <td class=textbg align=center>$onIndex</td>";

                    $globPrint .= "<td class=textbg align=center><a href=\"admin.cgi?do=Modules&act=delMod&m=$ref->{'BlockName'}&side=$side\">
                                         <font color=darkred></font></a></td>";

                                         %_ = ();
                  }

           $sth->finish();

           if($cntM == 0)
            {
              $globPrint .= "<tr><td colspan=7 class=textbg align=center><b>     !</b></td></tr>";
            }

           $globPrint .= "</table><br>\n";

     # Disconnecting from DB.

    return $globPrint;

    }

    ##################

   sub viewAll
   {
    my $on;
    my $onIndex;
    my $globPrint = "<br><table width=100% align=center border=0 cellspacing=0 cellpadding=3><tr>\n";
          $globPrint .= "<tr><td class=headline colspan=6 align=center><font size=4 color=white>    </font></td></tr>\n";
          $globPrint .= "<tr><td class=headline align=center><b></b></td>
                                <td class=headline align=center><b></b></td>
                                <td class=headline align=center><b></b></td>
                                <td class=headline align=center><b></b></td>
                                <td class=headline align=center><b></b></td>
                                <td class=headline align=center><b></b></td>
                               </tr>\n";

     # Connecting to DB.

     my $sth = $Libs::API::dbh->prepare("SELECT * FROM ${Libs::API::dbPrefix}_Modules  ORDER BY \"Number\" ASC");
           $sth->execute();

           my $isLoad;

               while (my $ref = $sth->fetchrow_hashref())
                 {
                   if($ref->{'BlockName'} eq "") { return $globPrint .= "<tr><td colspan=5 align=center><b>    </b></td></tr></table><br>"; }

                    if($ref->{'Active'}) { $on = "<a href=\"admin.cgi?do=Modules&act=off&name=$ref->{'BlockName'}\"><font color=darkred></font></a>"; }
                    else { $on = "<a href=\"admin.cgi?do=Modules&act=on&name=$ref->{'BlockName'}\"><font color=darkgreen></font></a>"; }

                    $API->db_get_hash_query("SELECT IsAlwLoad, IsChgPos, IsHaveUserMod, IsHaveAdminMod FROM ${Libs::API::dbPrefix}_Modules
                     WHERE BlockName=\"$ref->{'BlockName'}\"","IsAlwLoad, IsChgPos, IsHaveUserMod, IsHaveAdminMod");

                  if($_{'IsHaveUserMod'})
                  {
                    if($_{'IsAlwLoad'})
                     {
                     $isLoad = "<a href=\"admin.cgi?do=Modules&act=offLoad&name=$ref->{'BlockName'}\"></a>";
                      }
                    else
                     {
                     $isLoad = "<a href=\"admin.cgi?do=Modules&act=onLoad&name=$ref->{'BlockName'}\"> </a>";
                      }
                   }
                    else
                   {
                     $isLoad = "<b></b>";
                   }

                    $globPrint .= "<tr>
                                         <td class=textbg align=center>$ref->{'Number'}</td><td class=textbg align=center>";

                    if($_{'IsChgPos'})
                    {
                    $globPrint .= "<a href=\"admin.cgi?do=Modules&act=chgSide&m=$ref->{'BlockName'}&fside=none&tside=Left\"><img border=0 src=\"/Images/admin/left.gif\"></a> ";
                    $globPrint .= "<a href=\"admin.cgi?do=Modules&act=chgSide&m=$ref->{'BlockName'}&fside=none&tside=Center\"><img border=0 src=\"/Images/admin/center.gif\"></a> ";
                    $globPrint .= "<a href=\"admin.cgi?do=Modules&act=chgSide&m=$ref->{'BlockName'}&fside=none&tside=Right\"><img border=0 src=\"/Images/admin/right.gif\"></a></td>";
                    }

                    $globPrint .= "<td class=textbg align=center>$ref->{'Date'}</td>
                                         <td class=textbg align=center>";
                    $globPrint .= "<a href=\"admin.cgi?do=$ref->{'BlockName'}\">" if $_{'IsHaveAdminMod'};
                    $globPrint .= "$ref->{'BlockName'}";
                    $globPrint .= "</a>"  if $_{'IsHaveAdminMod'};
                    $globPrint .= "</td>
                                         <td class=textbg align=center>$on</td>
                                         <td class=textbg align=center>$isLoad</td>
                                         </tr>";
                  }

           $sth->finish();

     # Disconnecting from DB.

    $globPrint .= "</table><br>\n";

    return $globPrint;

    }

   $ADI->printPage($center);
 }

   ###################

   sub chgMods
   {
        $ADI->ModOnOff("Modules", 1) if $info{'act'} eq "on";
        $ADI->ModOnOff("Modules", 0) if $info{'act'} eq "off";

        $ADI->ModOnOff("Blocks", 1) if $info{'act'} eq "on" && $info{'type'} eq "block";
        $ADI->ModOnOff("Blocks", 0) if $info{'act'} eq "off" && $info{'type'} eq "block";

        $ADI->ModIndex(1) if $info{'act'} eq "onIndex" && $info{'type'} ne "block";
        $ADI->ModIndex(0) if $info{'act'} eq "offIndex" && $info{'type'} ne "block";

        $ADI->ModIndex(1, 1) if $info{'act'} eq "onIndex" && $info{'type'} eq "block";
        $ADI->ModIndex(0, 1) if $info{'act'} eq "offIndex" && $info{'type'} eq "block";

        $ADI->ModAlwLoad(1) if $info{'act'} eq "onLoad";
        $ADI->ModAlwLoad(0) if $info{'act'} eq "offLoad";

        $ADI->IndexModChg($info{'Index'}) if $info{'act'} eq "chgIndex";

        $ADI->chgPos($info{'from'}, $info{'to'}, "${info{'side'}}Block") if ($info{'act'} eq "chgPos" && $info{'to'} ne "" && $info{'from'} ne "");

        $ADI->chgSide($info{'fside'}, $info{'tside'}, $info{'m'}) if ($info{'act'} eq "chgSide" && $info{'tside'} ne "" && $info{'fside'} ne "");

        $ADI->delMod($info{'side'}, $info{'m'}) if ($info{'act'} eq "delMod" && $info{'side'} ne "" && $info{'m'} ne "");

        viewMods();

   }

   ###################

}
