#!/usr/bin/perl

#####################################

=head1 COPYRIGHT

  Copyright Notice
  ================

  Copyright 2004 Neuronix

  Copying Permission
  ------------------

  This script is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

  ********************************************************************

=head1 INFO

  Script Info
  ===========

  Author        : Neuronix
                     aka Nikolay Viguro

  Project       : nX - Engine (Codename: XEN)
                    This is CMS engine, writted on Perl language.

  Script        : index.cgi
                    This is main index page.

  Started      : 19/01/2004

=cut

#########################################

use strict;
use Libs::API;

#########################################

our $API = new Libs::API ( initMods => 0,
                                        readConf => 1 ); # Initalize constructor

### Starting Index print ###
#######################

print $API->printHeader("Index");   # Printering headers.

#########################################

our %conf = $API->readConfig("Config");
our %info = $API->getForms();
our %cook = $API->getCookies();

$API->statCnt(); #  .

Main() if !$conf{'UnderConstruction'};

   print $API->printUnderConstruction();
   exit(0);

#########################################

sub Main
{
   my $center;
   my $leftSide = $API->printSideBlock("Left",1);
   my $rightSide = $API->printSideBlock("Right",1);

   if($info{'login'} ne "invalid")
   {
            $center = $API->printSideBlock("Center",1);
    }
    else
    {
            $center = "<br>".$API->printBlock("Login invalid",
             "<br><center>  <b>\"-\"</b> !<br><br>   <br>   
                <b>Caps Lock</b>.</center>");
    }

    ########## Checking black-list ###############

    my ($banReason, $banExclude) = $API->checkBans();
    my $isEx;

    if($banExclude) { $isEx = "<br><br>      <b>$banExclude</b>."; }

    if($banReason && $banExclude !~ /Index/)
     {
        $center = "<br>".$API->printBlock(" ",
             "<br><center> <b> !</b><br><br>     <br>
                 <b>IP-</b>  :<br><br><i>$banReason</i>$isEx</center>");
      }

      ############################################

   ### Linking ###
   #############

   print $API->printBody($leftSide, $rightSide, $center);
   print $API->printFooter();

   $API->_dbDisconnect(); # Disconnecting from database server.

   exit(0);
}

#########################################
