#!/usr/bin/perl

#####################################

=head1 COPYRIGHT

  Copyright Notice
  ================

  Copyright 2004 Neuronix

  Copying Permission
  ------------------

  This script is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

  ********************************************************************

=head1 INFO

  Script Info
  ===========

  Author        : Neuronix
                     aka Nikolay Viguro

  Project       : nX - Engine (Codename: XEN)
                    This is CMS engine, writted on Perl language.

  Script        : install.cgi
                    This is setup script.

  Started      : 09/09/2004

=cut

#########################################
# Please, select your language !

our $lang = "RU"; # RU (default)

#########################################

use strict;
use vars qw/$dbDriver $dbUser $dbPass $dbPrefix $dbName $dbHost $dbPort/;

#########################################

our %lang = loadLang();
our %info = getForms();

goStep2() if $info{'step'} == 2;
goStep3() if $info{'step'} == 3;
goStep4() if $info{'step'} == 4;
goStep5() if $info{'step'} == 5;

#######################
####### STAGE I #######
#######################

printPage(1, printBlock($lang{'TITLEFORGREETINGS'}, $lang{'GREETINGS'}));

#######################
####### STAGE II ######
#######################

sub goStep2
{
  my $data;
  my $globPrint;
  my $c;
  my $err;
  my @drvs;

  $data = $lang{'STEP2INTRO'};

  eval 'use DBI;';

  $data .= $lang{'HAVEMODULEYES'} if !$@;

  if($@)
   {
    $data .= $lang{'HAVEMODULENODBI'};
        $err = 1;
   }

  $data .= $lang{'STEP2HAVEDBD'};

  eval '@drvs = DBI->available_drivers;';

  foreach my $line (@drvs)
   {
     $c = 1 if $line =~ /mysql/;
   }

  $data .= $lang{'HAVEMODULEYES'} if $c;

  if(!$c)
   {
    $data .= $lang{'HAVEMODULENODBD'};
                  $err = 1;
   }

  $data .= $lang{'STEP2HAVEMD5'};

   eval 'use Digest::MD5 qw/md5_hex/;';

  $data .= $lang{'HAVEMODULEYES'} if !$@;

  if($@)
   {
    $data .= $lang{'HAVEMODULENOMD5'};
                  $err = 1;
   }

  if($err)
   {
    $data .= $lang{'STEP2FAIL'};
    printPage(2, printBlock($lang{'TITLEFORSTEP2'}, $data));
   }

  $data .= $lang{'STEP2SUCCESS'};

  $data .= $lang{'FOUNDDEVVERSION'};

  $globPrint = printBlock($lang{'TITLEFORSTEP2'}, $data);

  ############### Section 2 ###############

  $data = "$lang{'ENTERDBPARAMS'}
                <form method=post action=install.cgi>
                <input type=hidden name=step value=3>
                <table border=0 cellspacing=1 cellpadding=1>
                <tr>
                <td align=left valign=top><div>$lang{'HOST'}: &nbsp;</div></td>
                <td><div><input type=text name=host></div><br></td>
                <td>&nbsp;&nbsp;</td>
                <td align=left valign=top><div>$lang{'LOGIN'}: &nbsp;</div></td>
                <td><div><input type=text name=login></div><br></td>
                 <td align=left valign=top><div>$lang{'PORT'}: &nbsp;</div></td>
                <td><div><input type=text name=port value=3306></div><br></td>
                </tr>
                <tr>
                <td align=left valign=top><div>$lang{'DBNAME'}: &nbsp;</div></td>
                <td><div><input type=text name=db></div><br></td>
                <td>&nbsp;&nbsp;</td>
                <td align=left valign=top><div>$lang{'PASS'}: &nbsp;</div></td>
                <td><div><input type=password name=passwd></div><br></td>
                <td align=left valign=top><div>$lang{'PREFIX'}: &nbsp;</div></td>
                <td><div><input type=text name=prefix value=\"xen\"></div><br></td>
                </tr>
                <tr>
                <td align=center colspan=8><div><input type=submit value=$lang{'SUBMIT'}></div></td>
                </tr>
                </table>
                </form>";

        $globPrint .= printBlock($lang{'TITLEFORSTEP2DB'}, $data);

  #######################################

  printPage(2, $globPrint);
}

#######################
####### STAGE III ######
#######################

sub goStep3
{
  my $data;
  my $globPrint;
  my $dbh;

  eval 'use DBI;';

  my $user = $info{'login'};
  my $prefix = $info{'prefix'};
  my $pass = $info{'passwd'};
  my $db = $info{'db'};
  my $host = $info{'host'};
  my $port = $info{'port'};

           my $dsn = "DBI:mysql:database=$db;host=$host;port=$port";
                 $dbh = DBI->connect($dsn, $user, $pass, { PrintError => 0, AutoCommit => 1 })
                  || printPage(3, printBlock($lang{'ERROR'}, $lang{'ERRORCONNECTDB'}."<b>".$DBI::errstr."</b></center><br>"), 1);

  open(SQL, "<Install/db.sql") || printPage(3, printBlock($lang{'ERROR'}, $lang{'ERROROPENDBFILE'}."<b>$!</b></center><br>"), 1);
    my @sql = <SQL>;
  close(SQL);

  my $status = $lang{'STEP3INTRO'};
  my $tmpl;
  my $name;
  my $cnt;

  foreach my $sql (@sql)
   {
     next if $sql =~ /^\n/;
     next if $sql =~ /^\#.*/;

     chomp $sql;

     $tmpl .= $sql;

     if($sql =~ /.*?;$/)
      {
        $name = "";
        $tmpl =~ s/\%PREFIX\%/$prefix/g;
        $dbh->do($tmpl) || printPage(3, printBlock($lang{'ERROR'}, $lang{'ERRORCREATETABLE'}."<b>".$DBI::errstr."</b></center><br>"), 1);
        $tmpl =~ /CREATE TABLE (.*?)\s/;
        $name = $1;
        $status .= $lang{'TABLECREATED'}." - <b>$name</b><br>\n" if $name;
        $cnt++ if $name;
        $tmpl = "";
      }
       else
      {
        next;
      }
   }

   $status .= $lang{'TABLECREATEDONE'};

   $globPrint .= printBlock($lang{'TITLEFORSTEP3'}, $status);

   #eval 'exec("chmod 777 Config/;chmod 755 index.cgi;chmod 755 admin.cgi; chmod 755 pages.cgi") if ($^O =~ /linux/ || $^O =~ /freebsd/);';
   #$status = $lang{'CHMODERROR'} if $@;

my $cfg = "
###################### Main Config ###########################
################# Generated by XEN - Install ####################

\$dbDriver = \"mysql\";
\$dbUser = \"$user\";
\$dbPass = \"$pass\";
\$dbName = \"$db\";
\$dbPrefix = \"$prefix\";
\$dbHost = \"$host\";
\$dbPort = \"$port\";

#############################################################
#############################################################
";

   open(CFG, ">Config/Main.cgi") || printPage(3, printBlock($lang{'ERROR'}, $lang{'ERROROPENCFGFILE'}."$!</b></center><br>"), 1);
    print CFG $cfg;
   close(CFG);

     my $installTime = time;

     open (IT, ">Config/InstallTime.cgi") || printPage(3, printBlock($lang{'ERROR'}, $lang{'ERROROPENCFGFILE'}."$!</b></center><br>"), 1);
      print IT $installTime;
     close (IT);

  printPage(3, $globPrint);
}

#######################
####### STAGE IV ######
#######################

sub goStep4
{
  my $data;
  my $globPrint;
  my $dbh;

  eval 'use DBI;';
  eval 'require "Config/Main.cgi";';

             my $dsn = "DBI:$dbDriver:database=$dbName;host=$dbHost;port=$dbPort";
                   $dbh = DBI->connect($dsn, $dbUser, $dbPass, { PrintError => 0, AutoCommit => 1 })
                                  || printPage(4, printBlock($lang{'ERROR'}, $lang{'ERRORCONNECTDB'}."<b>".$DBI::errstr."</b></center><br>"), 1);

  $data = $lang{'STEP4INTRO'};
  $globPrint = printBlock($lang{'INFO'}, $data);

  $data = "$lang{'STEP4INTRONEED'}
                      <table width=70% border=0 cellspacing=1 cellpadding=3 bgcolor=#ffffff align=center>
                        <form action=install.cgi method=POST>
                         <input type=hidden name=step value=5>
                          <tbody>
                            <tr>
                              <td width=30% class=headline colspan=2><font color=white><b>$lang{'YOURLOGIN'}: </b></font></td><td class=textbg>
                              <input type=text name=login value=Administrator> <font color=red>*</font>
                              </td>
                             </tr>
                            <tr><td class=headline colspan=2><font color=white><b>$lang{'YOURPASS'}: </b></font></td><td class=textbg>
                            <input type=password name=passwd> <font color=red>*</font>
                              </td>
                            </tr>
                            <tr><td class=headline colspan=2><font color=white><b>$lang{'YOURFIRSTLASTNAME'}: </b></font></td><td class=textbg>
                            <input style=\"width: 269px;\" type=text name=fio>
                              </td>
                            </tr>
                            <tr><td class=headline colspan=2><font color=white><b>$lang{'YOURCOUNTRY'}: </b></font></td><td class=textbg>
                            <input style=\"width: 269px;\" type=text name=country>
                              </td>
                            </tr>
                            <tr><td class=headline colspan=2><font color=white><b>$lang{'YOURCITY'}: </b></font></td><td class=textbg>
                            <input style=\"width: 269px;\" type=text name=city>
                              </td>
                            </tr>
                            <tr><td class=headline colspan=2><font color=white><b>$lang{'YOUREMAIL'}: </b></font></td><td class=textbg>
                            <input style=\"width: 269px;\" type=text name=email> <font color=red>*</font>
                              </td>
                            </tr>
                            <tr><td class=headline colspan=2><font color=white><b>$lang{'YOURHOMEPAGE'}: </b></font></td><td class=textbg>
                            <input style=\"width: 269px;\" type=text name=home>
                              </td>
                            </tr>
                            <tr><td class=headline colspan=2><font color=white><b>$lang{'YOURICQ'}: </b></font></td><td class=textbg>
                            <input style=\"width: 269px;\" type=text name=icq>
                              </td>
                            </tr>
                            <tr><td class=headline colspan=3 align=center><font color=white><b>$lang{'ABOUTYOU'}: </b></font></td></tr>
                            <tr>&nbsp;
                              <td colspan=3 class=textbg><textarea style=\"width: 98%;\" name=about rows=8></textarea></td>
                            </tr>
                            <tr><td align=right><input type=submit value=\"$lang{'NEXT'}\"></td></tr>
                          </tbody>
                          </form>
                        </table>
                        <br>
";

  $globPrint .= printBlock($lang{'TITLEFORSTEP4'}, $data);

  printPage(4, $globPrint);
}

#######################
####### STAGE V ######
#######################

sub goStep5
{
  my $data;
  my $globPrint;
  my $dbh;

  eval 'use DBI;';
  eval 'require "Config/Main.cgi";';
  eval 'use Digest::MD5 qw/md5_hex/;';

             my $dsn = "DBI:$dbDriver:database=$dbName;host=$dbHost;port=$dbPort";
                   $dbh = DBI->connect($dsn, $dbUser, $dbPass, { PrintError => 0, AutoCommit => 1 })
                                  || printPage(5, printBlock($lang{'ERROR'}, $lang{'ERRORCONNECTDB'}."<b>".$DBI::errstr."</b></center><br>"));

  if(!$info{'login'} || !$info{'passwd'} || $info{'email'} !~ /.*?\@.*?\.\w+/)
    {
      printPage(4, printBlock($lang{'ERROR'}, $lang{'DATANOTCORRECT'}));
    }

    $info{'passwd'} = md5_hex($info{'passwd'});
    my $avatar = "/Images/avatars/blank.gif"; # Default avatar (empty).

   $dbh->do("INSERT INTO ${dbPrefix}_Module_Users VALUES (\"$info{'login'}\", \"$info{'passwd'}\", \"$lang{'ADMINISTRATOR'}\", \"$info{'fio'}\",
                                                                                               \"$info{'country'}\" ,\"$info{'city'}\", \"$info{'home'}\", \"$info{'icq'}\",
                                                                                               \"$info{'email'}\", \"$info{'about'}\", \"$avatar\", 0, 0, 0, 0, 0, \"$lang{'NONEENTERS'}\")")

                                         || printPage(4, printBlock($lang{'ERROR'}, $lang{'WRITETODBERROR'}.$DBI::errstr."</b></center><br>"));

   $dbh->do("INSERT INTO ${dbPrefix}_Permissions VALUES (\"$lang{'ADMINISTRATOR'}\",\"$info{'login'}\", \"All\")")

                                         || printPage(4, printBlock($lang{'ERROR'}, $lang{'WRITETODBERROR'}.$DBI::errstr."</b></center><br>"));

  $data = $lang{'FINISH'};

  $globPrint = printBlock($lang{'TITLEFORSTEP5'}, $data);

   eval 'chmod 0755, "Config/";' if ($^O =~ /linux/ || $^O =~ /freebsd/); #     Config (29.11.04 Nix)
   $globPrint = $lang{'CHMODERROR'} if $@;

  printPage(5, $globPrint);
}

#########################################
#########################################

sub printPage
{
  my ($step, $data, $nonext) = @_;
  my $content;
  my $stage;
  my $pers;
  my $nextB;

$nextB = "<a href=\"install.cgi?step=2\"><img border=0 src=\"/Install/Pics/next.jpg\" title=\"$lang{'NEXT'}\"></a>" if $step == 1;
$nextB = "<a href=\"install.cgi?step=4\"><img border=0 src=\"/Install/Pics/next.jpg\" title=\"$lang{'NEXT'}\"></a>" if $step == 3 && !$nonext;

$stage = "&nbsp;<strong><big>&middot;</big></strong>&nbsp;<b>$lang{'STEP'} 1</b><br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 2<br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 3<br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 4<br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 5<br>\n" if $step == 1;

$stage = "&nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 1<br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;<b>$lang{'STEP'} 2</b><br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 3<br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 4<br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 5<br>\n" if $step == 2;

$stage = "&nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 1<br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 2<br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;<b>$lang{'STEP'} 3</b><br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 4<br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 5<br>\n" if $step == 3;

$stage = "&nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 1<br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 2<br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 3<br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;<b>$lang{'STEP'} 4</b><br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 5<br>\n" if $step == 4;

$stage = "&nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 1<br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 2<br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 3<br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;$lang{'STEP'} 4<br>\n
               &nbsp;<strong><big>&middot;</big></strong>&nbsp;<b>$lang{'STEP'} 5</b><br>\n" if $step == 5;

$pers = "<img src=\"/Install/Pics/0p.jpg\" title=\"0%\"><br><b>0%</b> $lang{'COMPLETE'}.<br><br>\n" if $step == 1;
$pers = "<img src=\"/Install/Pics/25p.jpg\" title=\"25%\"><br><b>25%</b> $lang{'COMPLETE'}.<br><br>\n" if $step == 2;
$pers = "<img src=\"/Install/Pics/50p.jpg\" title=\"50%\"><br><b>50%</b> $lang{'COMPLETE'}.<br><br>\n" if $step == 3;
$pers = "<img src=\"/Install/Pics/75p.jpg\" title=\"75%\"><br><b>75%</b> $lang{'COMPLETE'}.<br><br>\n" if $step == 4;
$pers = "<img src=\"/Install/Pics/100p.jpg\" title=\"100%\"><br><b>100%</b> $lang{'COMPLETE'}.<br><br>\n" if $step == 5;

$content = "
<html>
<head>
<title>XEN CMS Install ($lang{'STEP'} $step)</title>

<style>
body { background-color: white; margin-top: 5px; margin-right: 5px; margin-bottom: 5px; margin-left: 5px;}
td {  font-family: Tahoma, Verdana, Helvetica, arial, sans-serif; font-size: 12px; line-height: 14px; color: #3f71a3;}
.thinbar {  font-size: 2px; line-height: 2px;}
.headline {  background-color: #155c96; color: white;}
.date {  color: #3f71a3; background-color: white}
.main {  background-color: white}
.radiobutton { border-width: 0px; }
.textbg {  background-color: #f7fcfd; }

A { color: #3f71a3; }
A:hover { color: #3f71a3; }

input, textarea, select {
 background-color: #ffffff;
 border-style: solid;
 border-color: #426794;
 border-width: 1px;
 font-family: Tahoma, Verdana, Helvetica, arial, sans-serif;
 font-size: 10px;
 color: #000000;
 padding: 0px;
}
</style>

</head>

<body>

<table width=100% border=\"0\" cellspacing=\"1\" cellpadding=\"5\" bgcolor=\"white\" align=\"center\">
<tr>
  <td align=center colspan=2>
   <img src=\"/Install/Pics/head.jpg\">
  </td>
 </tr>
 <tr>
  <td valign=top height=209 width=14%>
   <table border=0 background=\"/Install/Pics/left.jpg\" height=209 width=100%>
   <tr><td align=center>
   $stage
   </td></tr>
   </table>
  </td>
  <td align=center>
  $pers
  <table width=80% border=\"0\" cellspacing=\"1\" cellpadding=\"5\" bgcolor=\"white\" align=\"center\">
  <tr><td>
  $data
  </td></tr>
  <tr><td align=center>
  $nextB
  </td></tr>
  </table>
  </td>
</tr>
  <tr>
   <td></td>
   <td align=center>
    <img src=\"/Install/Pics/foot.jpg\">
    <div><b>&copy; <a href=\"http://nxengine.hollosite.com\">Neuronix</a></b></div>
   </td>
  </tr>
</table>

</body>
</html>";


  print "Content-Type: text/html\n\n";
  print $content;
  exit(0);
}

#########################################

sub getForms
{
  my %FORM;

        my $buff;
        if ($ENV{REQUEST_METHOD} eq "POST") { read STDIN, $buff, $ENV{CONTENT_LENGTH} }
        else { $buff=$ENV{QUERY_STRING} }

        my @pairs = split(/&/, $buff);
        my $pair;
        foreach $pair (@pairs) {
                my ($name, $value) = split(/=/, $pair);
                $name =~ tr/+/ /;
                $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
                $value =~ tr/+/ /;
                $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
                $FORM{$name} = $value;
                $FORM{$name} =~ s/\</&lt;/g;
                $FORM{$name} =~ s/\>/&gt;/g;
                $FORM{$name} =~ s/\"/&quot;/g;
                $FORM{$name} =~ s/'//g;
                $FORM{$name} =~ s/`//g;
        }

  return %FORM;
}

sub printBlock
{
  my ($blockTitle, $blockContent, $type) = @_;
  my $globPrint;
  my $file = "block-$type.html";

  open(HTML,"<Skins/XGPro/$file") || printPage(1, printBlock("Error !", "Can't open Skins/XGPro/$file</b></center><br>"));
   my @content = <HTML>;
  close(HTML);

         foreach my $line (@content)
          {
            $line =~ s/__BLOCK_NAME__/$blockTitle/eg;
            $line =~ s/__CONTENT__/$blockContent/eg;

            $globPrint .= $line;
          }

  return $globPrint;
}

sub loadLang   # Multi-language support.
{
     my %cfg;

     open(CFG, "<Install/$lang.lang") || printPage(1, printBlock("Error !", "Can't open ${lang}.lang</b></center><br>"));

        while(<CFG>)
   {
        chomp;
        s/^\s+//;
        s/\s+$//;
        next if(!$_ || m/^#/);
            /(.*)\s=\s\"(.*?)\"/;
            $cfg{$1}= $2;
    }

    close (CFG);

    return %cfg;
}

