#!/usr/bin/perl

#####################################

=head1 COPYRIGHT

  Copyright Notice
  ================

  Copyright 2004 Neuronix

  Copying Permission
  ------------------

  This script is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

  ********************************************************************

=head1 INFO

  Script Info
  ===========

  Author        : Neuronix
                     aka Nikolay Viguro

  Project       : nX - Engine (Codename: XEN)
                    This is CMS engine, writted on Perl language.

  Script        : pages.cgi
                    This script provided viewing blocks, modules
                    and other functions.

  Started      : 19/01/2004

=cut

#########################################

use strict;
use Libs::API;

#########################################

our $API = new Libs::API ( initMods => 0,    # Initialize
                                         readConf => 1 ); # constructor.

#########################################

our %config = $API->readConfig("Config");
our %info = $API->getForms();
our %cook = $API->getCookies();
our $module = $info{'name'};
my $center;

$API->statCnt(); #  .

if($module =~ /\W+/) { print $API->respectHax0rs(); } # ... c001 h4x0rZ =)

### Starting Index print ###
#######################

print $API->printHeader($module) if $info{'action'} ne "down";   # Printering headers.

#########################################

UnderConstruction() if $config{'UnderConstruction'};

   my $leftSide = $API->printSideBlock("Left");
   my $rightSide = $API->printSideBlock("Right") if $module ne "Guest";

    ########## Checking black-list ###############

    my ($banReason, $banExclude) = $API->checkBans();
    my $isEx;

    if($banExclude) { $isEx = "<br><br>      <b>$banExclude</b>."; }

    if($banReason && $banExclude !~ $module)
     {
        $center = "<br>".$API->printBlock(" ",
             "<br><center> <b> !</b><br><br>     <br>
                 <b>IP-</b>  :<br><br><i>$banReason</i>$isEx</center>");
      }

      ############################################

      else
      {
        $center = center();
      }

   ### Linking ###
   #############

   print $API->printBody($leftSide, $rightSide, $center);
   print $API->printFooter();

   $API->_dbDisconnect(); # Disconnecting from database server.

   exit(0);

#########################################
#########################################

sub center
{
  my $cn;
  my $name = $info{'block'};

  return "<br>".$API->printBlock(" !","<br><center>     !</center>") if $module eq "";

  $API->singleInit($module);

  if($module eq "Blocks" && $name)
  {
      eval '$cn = $API->Blocks($name, 1);'
  } else {
      eval '$cn = $API->$module(%info);'; #  .
  }

  $cn = "<br><div align=center>
                    <h2> </h2><br>,   <b>$module</b>,   
                        <br>   .<br><br>$@</div>" if $@;

                        return $cn;
}

#########################################
#########################################

sub UnderConstruction
{
   print $API->printUnderConstruction();
   exit(0);
}
